package com.hywa.map.common.enums;

import com.hywa.map.common.exception.GlobalException;

public enum CommonEnum {
    MEN("男", (short) 1),
    WOMEN("女", (short) 2),

    INCREASE("增长", (short) 1),
    FALLING("下降", (short) 2),

    COUNTRY("country", (short) 0),
    PROVINCE("province", (short) 1),
    CITY("city", (short) 2),
    DISTRICT("county", (short) 3),
    TOWN("town", (short) 4),
    VILLAGE("village", (short) 5),

    SUCCESS("成功", (short) 0),
    FAILURE("失败", (short) 1),

    USER_CANCEL("用户已经注销，请联系管理员", (short) 1001),
    PASSWORD_ERROR("密码错误", (short) 1002),
    USER_UNREGISTERED_ERROR("用户未注册", (short) 1003),
    RE_LOGIN("认证失败，请重新登录！", (short) 1004),
    UNBOUND_REGION_ERROR("此账户未绑定区域，请联系管理员！", (short) 1005),
    USER_NAME_REPEATED("用户名称已经存在", (short) 1006),
    USER_TELEPHONE_REPEATED("电话号码已经存在", (short) 1007),
    TELEPHONE_FORMAL_ERROR("电话号码格式错误", (short) 1008),
    RE_LOGOUT("未正确退出,请重新退出", (short) 1009),
    UNIQUE_CHECK_ERROR("重复", (short) 1101),
    ENCRYPTION_ERROR("加密操作失败", (short) 1102),
    ILLEGAL_PARAMETER_ERROR("参数非法", (short) 2001),
    PARAMETER_NOT_NULL("参数不能为空", (short) 2002),
    ID_NOT_NULL("id不能为空", (short) 2009),
    TYPE_REFERENCED("类型被引用,请先删除引用", (short) 2003),
    FILE_NOT_NULL("文件不能为空", (short) 2004),
    FILE_CONTENT_NOT_NULL("文件内容不能为空", (short) 2005),
    FILE_UPLOAD_FAIL("文件上传失败", (short) 2006),
    DATE_TIME_FORMAT_ERR("请按正确的时间格式填写，格式为：年-月-日，例如：2018-06-28", (short) 2007),
    COORDINATE_PARSE_ERROR("坐标解析错误", (short) 2008),
    DEL_FAILURE("删除失败，对应用户不存在", (short) 2009),
    DEL_CURRENT_LOGIN_INFO("不能修改当前登录人信息", (short) 2010),
    DEL_ADMIN("不能修改超级管理员信息", (short) 2011),
    PERCENT_TO_DOUBLE_ERROR("百分数转换double格式错误", (short) 2012),
    PRODUCT_NAME_REPEATED("该商品已经存在", (short) 3001),
    FILE_NOT_FOUND("文件不存在", (short) 3002),
    FILE_REPEATED("文件已存在", (short) 3003),
    MAX_UPLOAD_SIZE_EXCEEDED("文件过大无法上传", (short) 3004),
    ROLE_NAME_REPEATED("角色名称已经存在", (short) 3002),
    ROLE_MENU_NOT_FOUND("权限范围不可为空", (short) 3014),
    MENU_NAME_REPEATED("菜单名称已经存在", (short) 3003),
    PASSWORD_REPEAT("修改前后密码不能相同", (short) 3004),
    USER_INFO_ERROR("用户信息有误", (short) 3005),
    TOO_BIG_A_DOCUMENT("文件内容过大,无法上传", (short) 3006),
    FILE_TYPE_ERROR("上传文件格式错误，仅支持.xls和.xlsx两种格式的文件", (short) 3007),
    NUMBER_FORMAT("格式异常", (short) 3009),
    FILE_CANNOT_BE_FOUND("文件未找到", (short) 3010),
    DATE_TIME_PARSE("时间格式异常,请使用指定时间格式", (short) 3011),
    OPERATOR_ERROR("不是对应办理人无法办理", (short) 3012),
    RECOMMEND_EXCEED("推荐文章不能超过五条", (short) 3013),
    AREA_ID_REPEATED("区域名称已经存在", (short) 3015),
    AREA_ID_NOT_FOUND("区域名称不存在", (short) 3016),
    CRAWLER_ASTRICT("省级账号才能查看爬虫信息", (short) 3017),
    IP_ERROR("无效IP", (short) 3018),
    ADMIN_ASTRICT("超级管理员不涉及业务操作", (short) 3019),
    NO_AUTHORITY("权限不足，请联系管理员！", (short) 3020),
    EVIDENCE_NOT_FOUND("请上传相应证据再进行举报", (short) 3021),
    EXCEL_DATA_VOID("数据为空无法下载", (short) 3022),
    AUTH_CODE_ERROR("验证码错误", (short) 3023),
    TIME_TYPE_ERROR("时间类型只能为天（1）和月（3）", (short) 3024),
    TITLE_IS_NULL("文章标题不能为空", (short) 3025),
    IS_RECOMMEND_IS_NULL("文章需表明是否首页推荐", (short) 3026),
    CONTENT_IS_NULL("文章内容不能为空", (short) 3027),
    COVER_IS_NULL("推荐文章必须上传封面图片", (short) 3028),
    AUTH_CODE_TIME_OUT("验证码超时", (short) 3029),
    LOGIN_TIMEOUT("秘钥错误",(short)3030),
    AREA_NO_FOUND("地区不在当前用户范围内，请重新选择",(short)3031),
    DATA_ERROR("导入数据时间格式异常",(short)3032),
    INTEGER_VAIL("必须为整数",(short)3033),
    AREA_UNMATCH_ROLE("用户角色不在地区范围内，请重新选择",(short)3034),
    USER_INFO_RESTRICT("不是对应创建人无法进行相应操作",(short)3035),
    ARG_NO_FOUND("参数名称与系统中名称不匹配",(short)3036),
    DATA_NO_FOUND("导入数据中日期不能为空",(short)3037),
    PRODUCT_NAME_NO_FOUND("导入数据中产品名称不能为空",(short)3038),
    MARKET_NAME_FOUND("导入数据中市场名称不能为空",(short)3039),
    DEL_STATE("事件已举报完成,证据无法删除",(short)3040),
    ABNORMAL_ACCOUNT("账号异常",(short)3041),
    AREA_USER_FOUND("区域被用户引用,请先删除区域下的用户",(short)3042),
    ROLE_USER_FOUND("角色被用户引用,请先删除角色下的用户",(short)3043),
    ROLE_SYS("不可以删除系统默认创建的角色",(short)3044),
    ROLE_NO_FOUND("角色不存在",(short)3045),
    MENU_NO_FOUND("请增加上级和本级默认角色的菜单权限",(short)3046),
    AREA_NO_MATCH("只允许修改本级的菜单权限",(short)3047),
    ROLE_DEFAULT("只允许上级修改系统创建的默认角色",(short)3048),
    THE_CALLING_SYSTEM_DID_NOT_START("调用系统未正常启动",(short)3049),
    BUSINESS_INFORMATION_CANNOT_BE_EMPTY("农企信息不能为空",(short)3050),
    PRICING_RELEASES_CANNOT_BE_EMPTY("定价发布信息不能为空",(short)3051),
    THE_ACCOUNT_IS_BANNED("账号被禁,无法使用",(short)3052),
    THREAD_BLOCKING_EXCEPTION("账号被禁,无法使用",(short)3053),
    ROLE_OF_SPOT("不允许修改或删除收购点权限角色",(short)3054),
    INFORMATION_CANNOT_BE_REMOVED_BY_REFERENCE("信息被引用,无法删除",(short)3055),
    THE_CONTENT_IS_TOO_LARGE_TO_SAVE("内容过长无法保存",(short)3056),
    CANNOT_BE_DELETED_IN_USE("农企信息在使用中,不能删除",(short)3057),
    ACQUISITION_POINT_CANNOT_BE_EMPTY("收购点不能为空",(short)3058),
    ERROR_FORMAT("保存数据失败,请检查数据格式",(short)3059),
    INDU_NAME_FOUND("行业名称已经存在",(short)3060),
    INDU_CODE_FOUND("行业编码已经存在",(short)3061),
    INDU_CODE_USED("行业编码被标准库引用，请先删除关联的标准库",(short)3062),
    LIB_NAME_FOUND("库名称已经存在",(short)3063),
    LIB_CODE_FOUND("库编码已经存在",(short)3064),
    LIB_CODE_USED("库编码被标准数据引用，请先删除关联的标准数据",(short)3065),
    SYS_DICT_NAME_FOUND("字典名称已经存在",(short)3066),
    SYS_DICT_CODE_FOUND("字典编码已经存在",(short)3067),
    SYS_DICT_CODE_USED("字典编码被下级数据引用，请先删除关联的下级数据",(short)3068),
    FILE_TEMPLATE_ERROR("数据模版不符",(short)3069),
    CHECK_DATA_ERROR("导入数据错误,请下载检查结果文件",(short)3070),
    DISABLE_ADMIN("不能禁用超级管理员信息", (short) 3071),
    DISABLE_SELF("不能禁用当前登录用户", (short) 3072),
    BRANCH_USED("机构被引用，请先删除关联的下级机构",(short)3073),
    BRANCH_NAME_FOUND("机构名称已经存在",(short)3074),
    DICT_TYPE_FOUND("字典类型已经存在",(short)3075),
    DICT_CODE_FOUND("字典编码已经存在",(short)3076),
    DICT_TYPE_USED("字典类型被下级数据引用，请先删除关联的下级数据",(short)3078),
    DICT_VALUE_FOUND("字典值已经存在",(short)3079),
    DICT_SEQ_FOUND("字典序列号已经存在",(short)3080),
    NOTICE_NAME_FOUND("标题名称已经存在",(short)3081),
    REPORT_NO_FOUND("报告编号已经存在",(short)3082),
    CORP_NAME_FOUND("企业名称已经存在",(short)3083),
    CORP_TEL_FOUND("联系电话已经存在",(short)3084),
    ID_NO_FOUND("id不存在",(short)3085),
    EXE_NUMBER_FOUND("行政处罚决定案号已经存在",(short)3086),
    USER_ICON_NO_FOUND("头像不能为空",(short)3087),
    BRANCH_USER_USED("机构被用户引用，请先删除关联的用户",(short)3088),
    NET_ERROR("通讯异常，请稍后重试！", (short) 3089),
    TOPIC_NAME_FOUND("专题名称已经存在",(short)3090),
    ORCHARD_CODE_FOUND("园区编码已经存在",(short)3091),
    ORCHARD_NAME_FOUND("园区名称已经存在",(short)3092),
    DB_SOURCE_NAME_FOUND("数据源名称已经存在",(short)3093),
    DB_SOURCE_USED("数据源存在关联数据，请先删除关联数据配置",(short)3094),
    MAP_NAME_FOUND("大屏名称已经存在",(short)3095),
    AREA_DATA_USED("数据应用于大屏，不可以删除",(short)3096),
    SCREEN_ERROR("口令错误",(short)3097),
    INTERNAL_ERROR("系统错误，请联系管理员！", (short) 9999);


    private String value;
    private Short index;

    CommonEnum(String sex, Short index) {
        this.setValue(sex);
        this.setIndex(index);
    }

    public String getValue() {
        return value;
    }

    public static String getSex(Short index) {
        if (index.equals(MEN.index)) {
            return MEN.getValue();
        } else if (index.equals(WOMEN.index)) {
            return WOMEN.getValue();
        } else {
            return null;
        }
    }

    public static short getIndex(String sex) {
        if (sex.trim().equals(MEN.value)) {
            return MEN.getIndex();
        } else if (sex.trim().equals(WOMEN.value)) {
            return WOMEN.getIndex();
        } else {
            throw new GlobalException("性别输入异常，性别只能为：男、女！");
        }
    }

    public Short getIndex() {
        return index;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public void setIndex(Short index) {
        this.index = index;
    }
}
