package com.hywa.map.common.enums;

import com.hywa.map.common.exception.GlobalException;

import java.util.Optional;

/**
 * 数据源
 */
public enum DataSource {

    NORTHLOGISTICSPARK("北部物流园","northLogisticsPark"),BUSINESSBUREAU("商务局", "businessBureau");

    private String value;
    private String name;

    DataSource(String value, String name) {
        this.setValue(value);
        this.setName(name);
    }

    public String getValue() {
        return value;
    }

    public String getName() {
        return name;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public void setName(String name) {
        this.name = name;
    }

    public static String getValue(String name) {
        for (DataSource i : DataSource.values()) {
            if (i.getName().equals(name)) {
                return i.value;
            }
        }
        if (Optional.ofNullable(name).isPresent()) {
            throw new GlobalException(CommonEnum.ILLEGAL_PARAMETER_ERROR.getIndex(), CommonEnum.ILLEGAL_PARAMETER_ERROR.getValue());
        }
        return null;
    }

    public static String getName(String value) {
        for (DataSource i : DataSource.values()) {
            if (i.getValue().equals(value)) {
                return i.name;
            }
        }
        if (Optional.ofNullable(value).isPresent()) {
            throw new GlobalException(CommonEnum.ILLEGAL_PARAMETER_ERROR.getIndex(), CommonEnum.ILLEGAL_PARAMETER_ERROR.getValue());
        }
        return null;
    }

}
