package com.hywa.map.common.enums;

import java.util.Optional;

import com.hywa.map.common.exception.GlobalException;

/**
 * 性别
 */
public enum Gender {

    WOMEN("女", (short) 0), MEN("男", (short) 1), UNKNOWN("未知", (short) 2);

    private String value;
    private Short index;

    Gender(String sex, Short index) {
        this.setValue(sex);
        this.setIndex(index);
    }

    public String getValue() {
        return value;
    }

    public Short getIndex() {
        return index;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public void setIndex(Short index) {
        this.index = index;
    }

    public static String getValue(Short index) {
        for (Gender i : Gender.values()) {
            if (i.getIndex().equals(index)) {
                return i.value;
            }
        }
        if(Optional.ofNullable(index).isPresent()){
            throw new GlobalException(CommonEnum.ILLEGAL_PARAMETER_ERROR.getIndex(), CommonEnum.ILLEGAL_PARAMETER_ERROR.getValue());
        }
        return null;
    }

}
