package com.hywa.map.common.enums;

import com.hywa.map.common.exception.GlobalException;

import java.util.Optional;

/**
 * 举报事件评价
 */
public enum InformEvaluate {

    VOID("无效办理", (short) 0), EVIDENCE("证据不足", (short) 1), COMPLETE("处理完成", (short) 2);

    private String value;
    private Short index;

    InformEvaluate(String sex, Short index) {
        this.setValue(sex);
        this.setIndex(index);
    }

    public String getValue() {
        return value;
    }

    public Short getIndex() {
        return index;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public void setIndex(Short index) {
        this.index = index;
    }

    public static String getValue(Short index){
        for (InformEvaluate i : InformEvaluate.values()) {
            if (i.getIndex().equals(index)) {
                return i.value;
            }
        }
        if(Optional.ofNullable(index).isPresent()){
            throw new GlobalException(CommonEnum.ILLEGAL_PARAMETER_ERROR.getIndex(), CommonEnum.ILLEGAL_PARAMETER_ERROR.getValue());
        }
        return null;
    }
}
