package com.hywa.map.common.enums;

import com.hywa.map.common.exception.GlobalException;

import java.util.Optional;

/**
 * 举报事件办理结果
 */
public enum InformResult {

    GREATSATISFACTION("非常满意", (short) 0), SATISFACTION("满意", (short) 1), DISSATISFACTION("不满意", (short) 2);

    private String value;
    private Short index;

    InformResult(String sex, Short index) {
        this.setValue(sex);
        this.setIndex(index);
    }

    public String getValue() {
        return value;
    }

    public Short getIndex() {
        return index;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public void setIndex(Short index) {
        this.index = index;
    }

    public static String getValue(Short index){
        for (InformResult i : InformResult.values()) {
            if (i.getIndex().equals(index)) {
                return i.value;
            }
        }
        if(Optional.ofNullable(index).isPresent()){
            throw new GlobalException(CommonEnum.ILLEGAL_PARAMETER_ERROR.getIndex(), CommonEnum.ILLEGAL_PARAMETER_ERROR.getValue());
        }
        return null;
    }
}
