package com.hywa.map.common.enums;

import com.hywa.map.common.exception.GlobalException;

import java.util.Optional;

/**
 * 区域类型
 */
public enum RegionType {

    PROVINCE("省", (short) 1), CITY("市", (short) 2), COUNTY("区/县", (short) 3);

    private String value;
    private Short index;

    RegionType(String sex, Short index) {
        this.setValue(sex);
        this.setIndex(index);
    }

    public String getValue() {
        return value;
    }

    public Short getIndex() {
        return index;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public void setIndex(Short index) {
        this.index = index;
    }

    public static String getValue(Short index){
        for (RegionType i : RegionType.values()) {
            if (i.getIndex().equals(index)) {
                return i.value;
            }
        }
        if(Optional.ofNullable(index).isPresent()){
            throw new GlobalException(CommonEnum.ILLEGAL_PARAMETER_ERROR.getIndex(), CommonEnum.ILLEGAL_PARAMETER_ERROR.getValue());
        }
        return null;
    }
}
