package com.hywa.map.common.enums;

import java.util.HashMap;
import java.util.Map;

/**
 * @author hywa
 * @create by 2018.08.09
 * @description: 天气参数信息，包括：天气现象编码 风力编码 方向编码
 */
public class WeatherConts {
    public static final Map<String, String> weatherMap;//天气现象编码
    public static final Map<String, String> windpowerMap;//风力编码
    public static final Map<String, String> winddireMap;//方向编码
    static
    {
        //初始化天气现象编码
        weatherMap = new HashMap<String, String>();
        weatherMap.put("中雨", "中雨");
        weatherMap.put("中雪", "中雪");
        weatherMap.put("霰", "冰雹");
        weatherMap.put("冰雹", "冰雹");
        weatherMap.put("冻雨", "冻雨");
        weatherMap.put("多云", "多云");
        weatherMap.put("大暴雨", "大暴雨");
        weatherMap.put("大雨", "大雨");
        weatherMap.put("大雪", "大雪");
        weatherMap.put("小雨", "小雨");
        weatherMap.put("小雪", "小雪");
        weatherMap.put("扬沙", "扬沙");
        weatherMap.put("晴", "晴");
        weatherMap.put("暴雨", "暴雨");
        weatherMap.put("暴雪", "暴雪");
        weatherMap.put("沙尘暴", "沙尘暴");
        weatherMap.put("强沙尘暴", "沙尘暴");
        weatherMap.put("浮尘", "浮尘");
        weatherMap.put("霾", "浮尘");
        weatherMap.put("大暴雨-特大暴雨", "特大暴雨");
        weatherMap.put("特大暴雨", "特大暴雨");
        weatherMap.put("阴", "阴");
        weatherMap.put("阵雨", "阵雨");
        weatherMap.put("阵雪", "阵雪");
        weatherMap.put("雨夹雪", "雨夹雪");
        weatherMap.put("雷阵雨", "雷阵雨");
        weatherMap.put("雷阵雨并伴有冰雹", "雷阵雨加冰雹");
        weatherMap.put("雷阵雨加冰雹", "雷阵雨加冰雹");
        weatherMap.put("雾", "雾");
        weatherMap.put("飑", "风");
        weatherMap.put("龙卷风", "风");
        //初始化风力编码
        windpowerMap = new HashMap<String, String>();
        windpowerMap.put("0", "无风");
        windpowerMap.put("1", "软风");
        windpowerMap.put("2", "轻风");
        windpowerMap.put("3", "微风");
        windpowerMap.put("4", "和风");
        windpowerMap.put("5", "清风");
        windpowerMap.put("6", "强风");
        windpowerMap.put("7", "劲风");
        windpowerMap.put("8", "大风");
        windpowerMap.put("9", "烈风");
        windpowerMap.put("10", "狂风");
        windpowerMap.put("11", "暴风");
        windpowerMap.put("12", "台风");
        //初始化方向编码
        winddireMap = new HashMap<String, String>();
        winddireMap.put("0", "无风向");
        winddireMap.put("1", "东北");
        winddireMap.put("2", "东");
        winddireMap.put("3", "东南");
        winddireMap.put("4", "南");
        winddireMap.put("5", "西南");
        winddireMap.put("6", "西");
        winddireMap.put("7", "西北");
        winddireMap.put("8", "北");
        winddireMap.put("9", "旋转不定");
    }

}
