package com.hywa.map.common.log;

import javassist.NotFoundException;

public class LogUtils {

    private static LogUtils mInstance;

    private LogUtils() {
    }

    public static LogUtils getInstance() {
        if (mInstance == null) {
            synchronized (LogUtils.class) {
                if (mInstance == null) {
                    mInstance = new LogUtils();
                }
            }
        }
        return mInstance;
    }

    public void setLog(String logStr) throws NotFoundException {
        String className = Thread.currentThread().getStackTrace()[2].getClassName();
        String methodName = Thread.currentThread().getStackTrace()[2].getMethodName();
        AnnotationUtils.getInstance()
                .setAnnotationFieldValue(className, methodName, Log.class.getName(), "log",
                        logStr);
    }
}
