package com.hywa.map.common.reverseSQL;

import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Date;
/**
 * @description 逆向工程入口
 * @author liuzhaohui
 * @createtime 2018年7月31日 上午10:43:12
 */
public class GenEntityMappingUtils {
	protected SimpleDateFormat format =  new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");  
	protected String[] colnames; // 列名数组  
	protected String[] colTypes; //列名类型数组  
	protected String[] colremarks; //列名描述备注  
	protected Long[] colSizes; //列名大小数组  
	protected String [] colisnull; //是否为空
    protected static final String basePackage = "map";
    protected String packageOutPath ="com.hywa."+basePackage;;//指定实体生成所在包的路径
	protected String htmlAddress = "templates/hywa";//HTML //生成指定路径
	protected String authorName = "hywa";//作者名字
	protected String tablename = "sys_user";//表名  
	protected String dbName= "meitan_smart_map";//数据库名字
	protected static final String URL ="jdbc:mysql://127.0.0.1:3306";
	protected static final String NAME = "root";  
	protected static final String PASS = "123456";
	protected static final String DRIVER ="com.mysql.jdbc.Driver";  

    /** 
     * 出口 
     *
     * @param args 
     * @throws SQLException 
     */  
    public static void main(String[] args) throws SQLException {
    	String[] tables = {
    			"t_topic_info"};
    	for (int i = 0; i < tables.length; i++) {
    		new GenEntityMysql(tables[i]).generate();
		}
    	
    }  
	/** 
     * 功能：获得列的数据类型 
     * @param sqlType 
     * @return 
     */  
    protected String sqlType2JavaType(String sqlType) {  
          
        if(sqlType.equalsIgnoreCase("bit")){  
            return "boolean";  
        }else if(sqlType.equalsIgnoreCase("tinyint")){  
            return "byte";  
        }else if(sqlType.equalsIgnoreCase("double")){  
            return "Double";  
        }else if(sqlType.equalsIgnoreCase("smallint")){  
            return "short";  
        }else if(sqlType.equalsIgnoreCase("int")){  
            return "int";  
        }else if(sqlType.equalsIgnoreCase("bigint")){  
            return "long";  
        }else if(sqlType.equalsIgnoreCase("float")){  
            return "float";  
        }else if(sqlType.equalsIgnoreCase("decimal") || sqlType.equalsIgnoreCase("numeric")   
                || sqlType.equalsIgnoreCase("real") || sqlType.equalsIgnoreCase("money")   
                || sqlType.equalsIgnoreCase("smallmoney")){  
            return "BigDecimal";  
        }else if(sqlType.equalsIgnoreCase("varchar") || sqlType.equalsIgnoreCase("char")   
                || sqlType.equalsIgnoreCase("nvarchar") || sqlType.equalsIgnoreCase("nchar")   
                || sqlType.equalsIgnoreCase("text") || sqlType.equalsIgnoreCase("tinytext")){  
            return "String";  
        }else if(sqlType.equalsIgnoreCase("datetime")||sqlType.equalsIgnoreCase("date")){  
            return "Date";  
        }else if(sqlType.equalsIgnoreCase("image")){  
            return "Blod";  
        }  
     
        return null;  
    }  
      
	/**
	 * 把第一个字母变为小写<br>
	 * 如：<br>
	 *     <code>str = "UserDao";</code><br>
	 *     <code>return "userDao";</code>
	 * @param str
	 * @return
	 */
    protected String getLowercaseChar(String str){
		return str.substring(0,1).toLowerCase()+str.substring(1);
	}
	/**
	 * 显示信息
	 * @param info
	 */
    protected void showInfo(String info){
		System.out.println("创建文件："+ info+ "成功！");
	}

	/**
	 * 获取系统时间
	 * @return
	 */
    protected static String getDate(){
		SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
		return simpleDateFormat.format(new Date());
	}
    
    /** 
     * 功能：将输入字符串的首字母改成大写 
     * @param str 
     * @return 
     */  
    protected String initcap(String str) {  
        char[] ch = str.toCharArray();  
        if(ch[0] >= 'a' && ch[0] <= 'z'){  
            ch[0] = (char)(ch[0] - 32);  
        }  
        str=new String(ch);
        while( str.indexOf("_")!=-1){
   
          String name=str.subSequence(str.indexOf("_")+1, str.indexOf("_")+2).toString();
          str = str.replace( "_"+name, name.toUpperCase());
        }
        return str;  
    } 

    /** 
     * 功能：生成实体类主体代码 
     * @param colnames 
     * @param colTypes 
     * @param
     * @return 
     */  
    protected String parse(String[] colnames, String[] colTypes, String[] colremarks) {  
        StringBuffer sb = new StringBuffer();  
        sb.append("package " + this.packageOutPath +"."+initcap(tablename).toLowerCase()+ ".entity"+";\r\n");
        sb.append("import java.util.Date;\r\n");
        sb.append("\r\n");  
        //注释部分  
        sb.append("   /**\r\n");  
        sb.append("    * "+tablename+" 实体类 对应表名\r\n");  
        sb.append("    * @create by "+format.format(new Date())+"\r\n");  
        sb.append("    * @author "+this.authorName+"\r\n"); 
        sb.append("    */ \r\n");  
        //实体部分  
        sb.append("public class " + initcap(tablename) +  " implements Serializable {\r\n");
        sb.append("\r\n"); 
        sb.append("\t private static final long serialVersionUID = 1L;\r\n");
        processAllAttrs(sb);//属性  
        processAllMethod(sb);//get set方法  
        sb.append("}\r\n");    
        return sb.toString();  
    }  
    
    /** 
     * 功能：生成所有属性 
     * @param sb 
     */  
    private void processAllAttrs(StringBuffer sb) {  
    	
        for (int i = 0; i < colnames.length; i++) {  
            //注释部分  
            sb.append("   /**\r\n");  
            sb.append("    * "+colremarks[i]+" \r\n");  
            sb.append("    */ \r\n"); 
            sb.append("\tprivate " + sqlType2JavaType(colTypes[i]) + " " + getLowercaseChar(initcap(colnames[i].toLowerCase())) + ";\r\n");  
        }    
    }  
  
    /** 
     * 功能：生成所有方法 
     * @param sb 
     */  
    private void processAllMethod(StringBuffer sb) {  
        for (int i = 0; i < colnames.length; i++) {  
            sb.append("\tpublic void set" + initcap(colnames[i].toLowerCase()) + "(" + sqlType2JavaType(colTypes[i]) + " " +   
            		getLowercaseChar(initcap(colnames[i].toLowerCase())) + "){\r\n");  
            sb.append("\tthis." + getLowercaseChar(initcap(colnames[i].toLowerCase())) + "=" + getLowercaseChar(initcap(colnames[i].toLowerCase())) + ";\r\n");  
            sb.append("\t}\r\n");  
            sb.append("\tpublic " + sqlType2JavaType(colTypes[i]) + " get" + initcap(colnames[i].toLowerCase()) + "(){\r\n");  
            sb.append("\t\treturn " + getLowercaseChar(initcap(colnames[i].toLowerCase())) + ";\r\n");  
            sb.append("\t}\r\n");  
        }    
    }  
    
    
    // html 中 #replace2 位置替换
    public StringBuffer replace2(){
    	StringBuffer sbf = new StringBuffer(); 
    	sbf.append("<th data-options=\"field:'id',width:80,hidden:'true'\">ID</th> \n"); 
    	   for(int i = 0; i < colnames.length; i++){
          	   if(!"id".equals(getLowercaseChar(initcap(colnames[i].toLowerCase())))){
          		 sbf.append("\t\t\t\t<th data-options=\"field:'"+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"',width:120\">"+colremarks[i]+"</th> \n"); 
          	   }  
    	   }
    	return sbf;
    }
    // html 中 #replace3 位置替换
    public StringBuffer replace3(){
    	StringBuffer sbf = new StringBuffer();
    	sbf.append("<input class=\"easyui-textbox\" type=\"hidden\" name=\"id\"/> \n"); 
    	for(int i = 0; i < colnames.length; i++){
    		if(!"id".equals(getLowercaseChar(initcap(colnames[i].toLowerCase())))){
    			sbf.append("\t\t\t\t<tr align=\"center\"> \n"); 
    			sbf.append("\t\t\t\t\t<td width=\"80\" align=\"right\">"+colremarks[i]+":</td> \n");
    			sbf.append("\t\t\t\t\t<td><input");
    		
    			if(colTypes[i].equalsIgnoreCase("decimal") || colTypes[i].equalsIgnoreCase("numeric")   || colTypes[i].equalsIgnoreCase("real") || colTypes[i].equalsIgnoreCase("money")   || colTypes[i].equalsIgnoreCase("smallmoney")  || colTypes[i].equalsIgnoreCase("int") || colTypes[i].equalsIgnoreCase("double")|| colTypes[i].equalsIgnoreCase("long")|| colTypes[i].equalsIgnoreCase("float")){
    				sbf.append(" class=\"easyui-numberbox\" type=\"text\"");
    				
    			}else if(colTypes[i].equalsIgnoreCase("datetime")||colTypes[i].equalsIgnoreCase("date")){
    				sbf.append(" class=\"easyui-datebox\" type=\"text\"");
    			}else{  
    	        	sbf.append(" class=\"easyui-textbox\" type=\"text\"");
    	        }
    			sbf.append("name=\""+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"\""); 
    			//validType="length[0,3]"
    			if("NO".equals(colisnull[i])){
    				sbf.append(" data-options=\"required:true\"");
    			}
    			
    			if(colSizes[i]!=0){
    				sbf.append(" validType=\"length[0,"+colSizes[i]+"]\"");
    				
    			}
    			sbf.append("/></td> \n");
    			
    			sbf.append("\t\t\t\t</tr> \n"); 
    		}  
    	}
    	return sbf;
    }

}
