package com.hywa.map.common.reverseSQL;


import com.hywa.map.common.utils.StringUtils;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;


/**
 * @description 逆向工程工具类
 * @author liuzhaohui
 * @createtime 2018年7月31日 上午10:43:30
 */
public class GenEntityMysql extends GenEntityMappingUtils{  
	
	
	public GenEntityMysql(String tableName){
		super.tablename=tableName;
	}
	public GenEntityMysql(){}
	
	
    /***
     * 生成对应代码
     * controller层
     * entity 实体层
     * service 层
     * serviceImp层
     * mapper 接口层（用的mybatis）
     * mapper .xml 层 （用的mybatis）
     * jsp 层（暂时不写）
     * by yfw 
     * @throws SQLException 
     * */
    public  void generate() throws SQLException{
    	//entity 实体层 生成
    	 createEntityMysql();
    	// * mapper 接口层（用的mybatis）//mapper .xml 层 （用的mybatis）
    	 createMapperInterface();
    	//service 层 接口
    	 createServiceInterface();
    	//serviceImpl 实现
    	 createServiceImpl();
    	//controller 层
    	 createController();
    	 //web html 层
    	 //createWebHtml();

    }
    
    
    /**
     * controller 层 
     * 单表简单 增 删 改 查 实现
     * 
     * **/
    public void createController(){
 	     try {  
              File directory = new File("");  
              //String path=this.getClass().getResource("").getPath();  
              String outputPath = directory.getAbsolutePath()+ "/src/main/java/"+ packageOutPath.replace('.', '/')+"/"+initcap(tablename).toLowerCase()+"/controller/"+initcap(tablename)+ "Controller.java";  
              File file3 = new File(directory.getAbsolutePath()+ "/src/main/java/"+ packageOutPath.replace('.', '/')+"/"+initcap(tablename).toLowerCase()+"/controller");
              if (file3.mkdir()) {
                  System.out.println("多级层文件夹下文件创建成功！创建了的文件为:" + file3.getAbsolutePath() + ",上级文件为:" + file3.getParent());
              }
              FileWriter fw = new FileWriter(outputPath);  
              PrintWriter pw = new PrintWriter(fw);  
              pw.println(controller());  
              pw.flush();  
              pw.close();  
          } catch (IOException e) {  
              e.printStackTrace();  
          }  
    }
    /** 
     * serviceImpl
     * 功能：生成serviceImpl 接口 主体代码 
     * 包括简单的 单表增删改查
     * @return 
     */  
    private String controller() {  
        StringBuffer sb = new StringBuffer();  
        sb.append("package " + this.packageOutPath + "."+initcap(tablename).toLowerCase()+".controller;\r\n");  
        //判断是否导入工具包  
		sb.append("import java.util.HashMap;\r\n");
		sb.append("import java.util.List;\r\n");
		sb.append("import java.util.Map;\r\n");
		sb.append("import org.springframework.beans.factory.annotation.Autowired;\r\n");
		sb.append("import org.springframework.stereotype.Controller;\r\n");
		sb.append("import org.springframework.util.StringUtils;\r\n");
		sb.append("import org.springframework.web.bind.annotation.RequestMapping;\r\n");
		sb.append("import org.springframework.web.bind.annotation.RequestMethod;\r\n");
		sb.append("import org.springframework.web.bind.annotation.ResponseBody;\r\n");
		sb.append("import "+this.packageOutPath+"."+initcap(tablename).toLowerCase()+".entity."+initcap(tablename)+";\r\n");
		sb.append("import "+this.packageOutPath+"."+initcap(tablename).toLowerCase()+".service."+initcap(tablename)+"Service;\r\n");
        sb.append("\r\n");  
        //注释部分  
        sb.append("/**\r\n"); 
        sb.append("* "+tablename+"  对应Controller 实现类\r\n");  
        sb.append("* @create by "+format.format(new Date())+"\r\n");
        sb.append("* @author "+this.authorName+"\r\n"); 
        sb.append("*/ \r\n");  
        //贴注解部分
        sb.append("@Controller \r\n");  
        sb.append("@RequestMapping(\"/"+StringUtils.firstCharToLowerCase(initcap(tablename))+"\") \r\n");
        sb.append("public class " + initcap(tablename) +  "Controller {\r\n");
        sb.append("\r\n"); 
        
       // 简单接口部分属性  
        processController(sb);
        sb.append("}\r\n");    
        return sb.toString();  
    } 
    
    
    
    
    /**
     * 具体简单实现部分
     * 
    **/
    private void processController(StringBuffer sb) {  
        	sb.append("\t@Autowired \r\n");
        	sb.append("\tprivate "+initcap(tablename)+"Service "+initcap(tablename).toLowerCase()+"Service; \r\n");

            // 查询接口list
            sb.append("\r\n");
            sb.append("   /**\r\n"); 
            sb.append("    * @description  这是一个 查所有 列表的 方法  Dao 层已经生成规则的 条件查询 如需要加条件，请自己按规则 DIV \r\n");  
            sb.append("    */ \r\n");    
            sb.append("\t@ResponseBody\r\n");
            sb.append("\t@RequestMapping(value=\"/search\",method = RequestMethod.GET) \r\n");
            sb.append("\tpublic AjaxJson search(PageBean pageBean){  \r\n"); 
            sb.append("\t\t Map<String,Object> equal =new HashMap<String, Object>();//等于查询条件 \r\n");
            sb.append("\t\t Map<String,Object> like =new HashMap<String, Object>();//模糊查询条件 \r\n");
            sb.append("\t\t String order =null;//模糊查询条件 \r\n");
            sb.append("\t\tList<Map<String, Object>> list= "+initcap(tablename).toLowerCase()+"Service.search(reMap(),equal,order,getPageBean(pageBean),like); \r\n"); 
            sb.append("\t\tint total= "+initcap(tablename).toLowerCase()+"Service.searchTotals(equal,like); \r\n"); 
            sb.append("\t\treturn fillingReturnBody(pageBean,list,total); \r\n");
            sb.append("\t}\r\n"); 

            
            //查看 
            sb.append("   /**\r\n"); 
            sb.append("    * @description  "+initcap(tablename) +" 根据id 查看信息  \r\n");  
            sb.append("    * @return  \r\n"); 
            sb.append("    */ \r\n");  
            sb.append("\t@ResponseBody\r\n");
            sb.append("\t@RequestMapping(value=\"/select\",method = RequestMethod.GET) \r\n");
            sb.append("\tpublic AjaxJson select(String id){  \r\n"); 
            sb.append("\t\tMap<String,Object> map ="+initcap(tablename).toLowerCase()+"Service.selectById(id); \r\n"); 
            sb.append("\r\n"); 
            sb.append("\t\treturn fillingReturnBody(map);\r\n");
            sb.append("\t}\r\n"); 
            
            
          //新增 实现
            sb.append("   /**\r\n"); 
            sb.append("    * @description  "+initcap(tablename) +" 新增 修改 根据 id 判断 单表  考虑通用性，只封装了id 其他创建时间 创建人，自己根据表单需要来做调整 \r\n");  
            sb.append("    */ \r\n"); 
            sb.append("\t@ResponseBody\r\n");
            sb.append("\t@RequestMapping(value=\"/save\",method = RequestMethod.POST) \r\n");
            sb.append("\tpublic AjaxJson saveOrUpdate( "+initcap(tablename)+" "+initcap(tablename).toLowerCase()+"){  \r\n"); 
            sb.append("\r\n"); 
            sb.append("\tint num=0;//0失败1成功\r\n"); 
            sb.append("\t\t if(StringUtils.isEmpty("+initcap(tablename).toLowerCase()+")){\r\n");
            sb.append("\t\t\treturn new AjaxJson( AjaxJson.FAILURE,AjaxJson.MSGNULL);\r\n");   
            sb.append("\t\t }         \r\n");
            sb.append("\t\tif(StringUtils.isEmpty("+initcap(tablename).toLowerCase()+".getId())){\r\n");
            sb.append("\t\t\t"+initcap(tablename).toLowerCase()+".setId(UUIDUtils.newGUID());\r\n");//生成id的工具类 
            sb.append("\t\t\tnum="+initcap(tablename).toLowerCase()+"Service.add("+initcap(tablename).toLowerCase()+");//新增\r\n");
            sb.append("\t\t}else{\r\n");
            sb.append("\t\t\tnum="+initcap(tablename).toLowerCase()+"Service.update("+initcap(tablename).toLowerCase()+");//修改\r\n");
            sb.append("\t\t}\r\n");
            sb.append("\t\tif(num==1){\r\n");
            sb.append("\t\t\treturn new AjaxJson(AjaxJson.SUCCESS,AjaxJson.MSGSUCCESS);  //成功返回\r\n");
            sb.append("\t\t}\r\n");
            sb.append("\t\treturn new AjaxJson(AjaxJson.FAILURE,AjaxJson.MSGFAILURE);  //失败返回\r\n");
            sb.append("\t}\r\n"); 
           
            /**
        	 * 物理删除
        	 */
            sb.append("   /**\r\n"); 
            sb.append("    * @description  "+initcap(tablename) +" 删除 根据 id 判断 DAO层 有批量逻辑/物理删除  有需要自己div\r\n");  
            sb.append("    * @return AjaxJson \r\n"); 
            sb.append("    */ \r\n"); 
            sb.append("\t@ResponseBody\r\n");
            sb.append("\t@RequestMapping(value=\"/delete\",method = RequestMethod.GET) \r\n");
            sb.append("\tpublic AjaxJson delete(String id){  \r\n"); 
            sb.append("\r\n"); 
            sb.append("\t\t if(StringUtils.isEmpty(id)){\r\n");
            sb.append("\t\t\treturn new AjaxJson( AjaxJson.FAILURE,AjaxJson.MSGNULL);\r\n");   
            sb.append("\t\t }         \r\n");
            sb.append("\t\t\tfinal int num="+initcap(tablename).toLowerCase()+"Service.put(id);//删除\r\n");
            sb.append("\t\tif(num==1){\r\n");
            sb.append("\t\t\treturn new AjaxJson(AjaxJson.SUCCESS,AjaxJson.MSGSUCCESS);  //成功返回\r\n");
            sb.append("\t\t}\r\n");
            sb.append("\t\treturn new AjaxJson(AjaxJson.FAILURE,AjaxJson.MSGFAILURE);  //失败返回\r\n");
            sb.append("\t}\r\n"); 
        	
            
            /**
             * 返回字段map封装
             * */
            sb.append("   /**\r\n"); 
            sb.append("    * @description  返回字段map封装 \r\n");  
            sb.append("    * @return Map \r\n"); 
            sb.append("    */ \r\n"); 
            sb.append("\tprivate Map<String,Object> reMap(){  \r\n"); 
            sb.append("\r\n"); 
            sb.append("\t\t Map<String,Object> reField =new HashMap<String, Object>();//返回字段 \r\n");
            for(int i = 0; i < colnames.length; i++){
          	   sb.append("\t\t\treField.put(\""+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"\",\""+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"\");//"+colremarks[i]+" \n"); 
             }
            sb.append("\t\t\t return reField;//返回字段 \r\n");
            sb.append("\t}\r\n"); 
            
            
    }
            
      
    /**
     * serviceimpl 接口层实现 
     * 单表简单 增 删 改 查 实现
     * 
     * **/
    public void createServiceImpl(){
 	     try {  
              File directory = new File("");  
              //String path=this.getClass().getResource("").getPath();  
              String outputPath = directory.getAbsolutePath()+ "/src/main/java/"+ packageOutPath.replace('.', '/')+"/"+initcap(tablename).toLowerCase()+"/service/impl/"+initcap(tablename)+ "ServiceImpl.java";  
              File file3 = new File(directory.getAbsolutePath()+ "/src/main/java/"+ packageOutPath.replace('.', '/')+"/"+initcap(tablename).toLowerCase()+"/service/impl");
              if (file3.mkdir()) {
                  System.out.println("多级层文件夹下文件创建成功！创建了的文件为:" + file3.getAbsolutePath() + ",上级文件为:" + file3.getParent());
              }
              FileWriter fw = new FileWriter(outputPath);  
              PrintWriter pw = new PrintWriter(fw);  
              pw.println(serviceImpl());  
              pw.flush();  
              pw.close();  
          } catch (IOException e) {  
              e.printStackTrace();  
          }  
    }
    /** 
     * serviceImpl
     * 功能：生成serviceImpl 接口 主体代码 
     * 包括简单的 单表增删改查
     * @return 
     */  
    private String serviceImpl() {  
        StringBuffer sb = new StringBuffer();  
        sb.append("package " + this.packageOutPath + "."+initcap(tablename).toLowerCase()+".service.impl;\r\n");  
        //判断是否导入工具包  
        sb.append("import java.util.List;\r\n");
		sb.append("import java.util.Map;\r\n");
		sb.append("import org.springframework.beans.factory.annotation.Autowired;\r\n");
		sb.append("import org.springframework.stereotype.Service;\r\n");
		sb.append("import org.springframework.transaction.annotation.Transactional;\r\n");
		sb.append("import "+this.packageOutPath+"."+initcap(tablename).toLowerCase()+".mapper."+initcap(tablename)+"Mapper;\r\n");
		sb.append("import "+this.packageOutPath+"."+initcap(tablename).toLowerCase()+".service."+initcap(tablename)+"Service;\r\n");
        sb.append("\r\n");  
        //注释部分  
        sb.append("/**\r\n"); 
        sb.append("* "+tablename+"  对应ServiceImpl 实现类\r\n");  
        sb.append("* @create by "+format.format(new Date())+"\r\n");
        sb.append("* @author "+this.authorName+"\r\n"); 
        sb.append("*/ \r\n");  
        //贴注解部分
        sb.append("@Service \r\n");  
        sb.append("public class " + initcap(tablename) +  "ServiceImpl implements "+ initcap(tablename) + "Service{\r\n");
        sb.append("\r\n"); 
       // 简单接口部分属性  
        processServiceIpml(sb);
        sb.append("}\r\n");    
        return sb.toString();  
    }  
    
    
    /**
     * 具体简单接口部分
     * 
    **/
    private void processServiceIpml(StringBuffer sb) {  
        	sb.append("\t@Autowired \r\n");
        	sb.append("\tprivate "+initcap(tablename)+"Mapper "+initcap(tablename).toLowerCase()+"Mapper; \r\n");
        	
    		//查询接口
 	   	   sb.append("\r\n");
           sb.append("\t@Override \r\n");
 	       sb.append("\tpublic List<Map<String, Object>> search( Map<String,Object> reField, Map<String,Object> equal,String order,PageBean limit ,Map<String,Object> like ){  \r\n\n");  
 	       sb.append(" \t \t  return "+initcap(tablename).toLowerCase()+"Mapper.search(reField,equal,order,limit,like);\r\n"); 
 	       sb.append("\t}  \r\n");  
		   

 			//查询总条数接口
 	   	   sb.append("\r\n");  
 	       sb.append("\tpublic int searchTotals( Map<String,Object> equal,Map<String,Object> like ){  \r\n\n");  
 	       sb.append(" \t \t  return "+initcap(tablename).toLowerCase()+"Mapper.searchTotals(equal,like);\r\n"); 
 	       sb.append("\t}  \r\n");  
 		   

	   		//新增 接口
       	   sb.append("\r\n");
           sb.append("\tpublic int add(BaseEntity "+initcap(tablename).toLowerCase()+"){ \r\n");  
           sb.append("\t\tint i= "+initcap(tablename).toLowerCase()+"Mapper.add("+initcap(tablename).toLowerCase()+");\r\n");
 	       sb.append("\t\tif(i<1){\r\n");
 	       sb.append("\t\t\t throw new GlobalException(EnumSet.FAILURE);        \r\n");
 	       sb.append("\t\t }\r\n");
 	       sb.append(" \t\treturn 1;\r\n"); 
 	       sb.append("\t}  \r\n");  

 	           
           //修改 接口
           sb.append("\r\n");
          sb.append("\t@Transactional\r\n");
           sb.append("\tpublic int update(BaseEntity "+initcap(tablename).toLowerCase()+"){  \r\n");  
           sb.append("\t\tint i= "+initcap(tablename).toLowerCase()+"Mapper.update("+initcap(tablename).toLowerCase()+");\r\n");
 	       sb.append("\t\tif(i<1){\r\n");
 	       sb.append("\t\t\t throw new GlobalException(EnumSet.FAILURE);        \r\n");
 	       sb.append("\t\t }\r\n");
 	       sb.append(" \t\treturn 1;\r\n"); 
 	       sb.append("\t}  \r\n");  
 	           
           // 删除接口
           sb.append("\r\n");
           sb.append("\tpublic int put(String id){  \r\n");    
           sb.append("\t\tint i= "+initcap(tablename).toLowerCase()+"Mapper.put(id);\r\n");
 	       sb.append("\t\tif(i<1){\r\n");
 	       sb.append("\t\t\t throw new GlobalException(EnumSet.FAILURE);        \r\n");
 	       sb.append("\t\t }\r\n");
 	       sb.append(" \t\treturn 1;\r\n"); 
 	       sb.append("\t}  \r\n");  
 	           
           // 删除接口
           sb.append("\r\n");  
           sb.append("\tpublic int delete(String id){  \r\n"); 
           sb.append("\t\tint i= "+initcap(tablename).toLowerCase()+"Mapper.delete(id);\r\n");
 	       sb.append("\t\tif(i<1){\r\n");
 	       sb.append("\t\t\t throw new GlobalException(EnumSet.FAILURE);        \r\n");
 	       sb.append("\t\t }\r\n");
 	       sb.append(" \t\treturn 1;\r\n"); 
 	       sb.append("\t}  \r\n");
 	        
           // 查询接口 根据id 来查询
           sb.append("\r\n");
           sb.append("\tpublic Map<String,Object> selectById(String id){  \r\n");  
           sb.append(" \t\treturn "+initcap(tablename).toLowerCase()+"Mapper.selectById(id);\r\n"); 
 	       sb.append("\t}  \r\n");
     
        	
    }  
    /**
     * service 接口层 
     * 单表简单 增 删 改 查 接口
     * 
     * **/
    public void createServiceInterface(){
 	     try {  
              File directory = new File("");  
              String outputPath = directory.getAbsolutePath()+ "/src/main/java/"+ packageOutPath.replace('.', '/')+"/"+initcap(tablename).toLowerCase()+"/service/"+"/"+initcap(tablename)+ "Service.java";  
              File file3 = new File(directory.getAbsolutePath()+ "/src/main/java/"+ packageOutPath.replace('.', '/')+"/"+initcap(tablename).toLowerCase()+"/service");
              if (file3.mkdir()) {
                  System.out.println("多级层文件夹下文件创建成功！创建了的文件为:" + file3.getAbsolutePath() + ",上级文件为:" + file3.getParent());
              }
              FileWriter fw = new FileWriter(outputPath);  
              PrintWriter pw = new PrintWriter(fw);  
              pw.println(serviceInterface());  
              pw.flush();  
              pw.close();  
          } catch (IOException e) {  
              e.printStackTrace();  
          }  
    }
    /** 
     * 
     * serviceInterface
     * 功能：生成service 接口 主体代码 
     * 包括简单的 单表增删改查
     * @return 
     */  
    private String serviceInterface() {  
        StringBuffer sb = new StringBuffer();  
        sb.append("package " + this.packageOutPath + "."+initcap(tablename).toLowerCase()+".service;\r\n");
        sb.append("\r\n");  
        //注释部分  
        sb.append("/**\r\n"); 
        sb.append("* "+tablename+"  对应ServiceInterface 接口类\r\n");  
        sb.append("* @create by "+format.format(new Date())+"\r\n");
        sb.append("* @author "+this.authorName+"\r\n"); 
        sb.append("*/ \r\n");  
        //类部部分  
        sb.append("public interface " + initcap(tablename) +  "Service {\r\n");
        sb.append("\r\n"); 
        sb.append("}\r\n");    
        return sb.toString();  
    }  

    
    
    
    
   /**
    * mapper 接口层（用的mybatis）
    * 单表简单 增 删 改 查 接口
    * 
    * **/
   public void createMapperInterface(){
	     try {  
             File directory = new File("");  
             String outputPath = directory.getAbsolutePath()+ "/src/main/java/"+ packageOutPath.replace('.', '/')+"/"+initcap(tablename).toLowerCase()+"/mapper/"+"/"+initcap(tablename)+ "Mapper.java";  
            // String outputPath1 = directory.getAbsolutePath()+ "/src/main/java/"+ packageOutPath.replace('.', '/')+"/"+initcap(tablename).toLowerCase()+"/mapper/"+"/"+initcap(tablename)+ "Mapper.xml";  
             File file3 = new File(directory.getAbsolutePath()+ "/src/main/java/"+ packageOutPath.replace('.', '/')+"/"+initcap(tablename).toLowerCase()+"/mapper");
             if (file3.mkdir()) {
                 System.out.println("多级层文件夹下文件创建成功！创建了的文件为:" + file3.getAbsolutePath() + ",上级文件为:" + file3.getParent());
             }
             FileWriter fw = new FileWriter(outputPath);  
           //  FileWriter fw1 = new FileWriter(outputPath1);  
           //  PrintWriter pw1 = new PrintWriter(fw1);  
            // pw1.println(mapperXml());  //XML
            // pw1.flush();  
            // pw1.close();  
             PrintWriter pw = new PrintWriter(fw);  
             pw.println(mapperInterface());  //接口
             pw.flush();  
             pw.close();  
             createMapperXml();
         } catch (IOException e) {  
             e.printStackTrace();  
         }  
   }
   
   
   /**
    * mapper 接口层（用的mybatis）
    * 单表简单 增 删 改 查 接口
    * 
    * **/
   public void createMapperXml(){
	     try {  
             File directory = new File("");  
             String outputPath1 = directory.getAbsolutePath()+ "/src/main/resources/com/hywa/"+GenEntityMappingUtils.basePackage+"/dao/mapper"+initcap(tablename).toLowerCase()+"/"+initcap(tablename)+ "Mapper.xml";
             File file3 = new File(directory.getAbsolutePath()+ "/src/main/resources/com/hywa/"+GenEntityMappingUtils.basePackage+"/dao/mapper"+initcap(tablename).toLowerCase());
             if (file3.mkdir()) {
                 System.out.println("多级层文件夹下文件创建成功！创建了的文件为:" + file3.getAbsolutePath() + ",上级文件为:" + file3.getParent());
             }
             FileWriter fw1 = new FileWriter(outputPath1);  
             PrintWriter pw1 = new PrintWriter(fw1);  
             pw1.println(mapperXml());
             pw1.flush();  
             pw1.close(); 
         } catch (IOException e) {  
             e.printStackTrace();  
         }  
   }
   

   /** 
    * 
    * MapperInterface 实现祖始类
    * 功能：生成mapper 接口 主体代码 
    * 包括简单的 单表增删改查
    * @return 
    */  
   private String mapperInterface() {  
       StringBuffer sb = new StringBuffer();  
       sb.append("package " + this.packageOutPath + "."+initcap(tablename).toLowerCase()+".mapper;\r\n");  
       sb.append("import org.apache.ibatis.annotations.Mapper;\r\n");
      // sb.append("import "+this.packageOutPath+"."+initcap(tablename).toLowerCase()+".entity."+initcap(tablename)+";\r\n");
       sb.append("\r\n");  
       //注释部分  
       sb.append("/**\r\n"); 
       sb.append("* "+tablename+"  对应mapperInterface 接口类\r\n");  
       sb.append("* @create by "+format.format(new Date())+"\r\n");
       sb.append("* @author "+this.authorName+"\r\n"); 
       sb.append("*/ \r\n");  
       //贴注解部分
       sb.append("@Mapper \r\n");  
       //类部部分  
       sb.append("public interface " + initcap(tablename) +  "Mapper {\r\n");
       sb.append("\r\n");    
      // 简单接口部分属性  
       //processInterface(sb);
       sb.append("}\r\n");    
       return sb.toString();  
   }  
   /** 
    * 
    * MapperInterface
    * 功能：生成mapper 接口 主体代码 
    * 包括简单的 单表增删改查
    * @return 
    */  
   private String mapperXml() {  
	   StringBuffer sb = new StringBuffer();  
	   sb.append("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\r\n");  
	   //判断是否导入工具包  
	   sb.append("<!DOCTYPE mapper PUBLIC \"-//mybatis.org//DTD Mapper 3.0//EN\" \"http://mybatis.org/dtd/mybatis-3-mapper.dtd\" >\r\n");  
	   sb.append("<mapper namespace=\""+packageOutPath+"."+"dao"+".mapper."+initcap(tablename)+ "Mapper\" >\r\n");
	   processXml(sb);
	   sb.append("</mapper>\r\n");    
	   return sb.toString();  
   }  

   /**
    * 具体简单接口部分
    * 
   **/
   private void processXml(StringBuffer sb) {  
	  
	   
	   //根据id查询  返回一个对象值  
	   sb.append("\r\n");
	   sb.append("\t<!-- 根据id查询 "+tablename+" 返回一个map 返回字段字段根据 接口传来的字段-->\r\n");
	   sb.append("\t<select id=\"selectById\" resultType=\"java.util.HashMap\">\r\n");
	   sb.append("\t\tSELECT \r\n");
	   for (int i = 0; i < colnames.length; i++) { 
		   if(!"id".equals(colnames[i].toLowerCase())){
			   sb.append("\t\t\tA."+colnames[i]+" AS " +getLowercaseChar(initcap(colnames[i].toLowerCase()))+",\r\n"); 	   
		   }
       } 
	   sb.append("\t\tA.id AS id\r\n");	
	   sb.append("\t\tFROM \r\n");
	   sb.append("\t\t\t"+tablename.toLowerCase()+" A \r\n");
	   sb.append("\t\tWHERE \r\n");
	   sb.append("\t\t\tA.id=#{id} \r\n");
	   sb.append("\t\t</select> \r\n");
	 
	   
	   
	   
	   //根据map 条件查询  返回一个list
	   sb.append("\r\n");
	   sb.append("\t<!-- 根据  条件 查询单表  分页、模糊、等于、排序、返回字段 返回一个list -->\r\n");
	   sb.append("\t<select id=\"search\" resultType=\"java.util.HashMap\" >\r\n");
	   sb.append("\t\tSELECT \r\n");
   
	   for (int i = 0; i < colnames.length; i++) { 
		   if(!"id".equals(colnames[i].toLowerCase())){
		
			   if(colTypes[i].equalsIgnoreCase("varchar") || colTypes[i].equalsIgnoreCase("char")   
		                || colTypes[i].equalsIgnoreCase("nvarchar") || colTypes[i].equalsIgnoreCase("nchar")   
		                || colTypes[i].equalsIgnoreCase("text") || colTypes[i].equalsIgnoreCase("tinytext")){
			    	  sb.append("\t\t\t<if test=\"reField."+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"!= null and reField."+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"!=''\"> \r\n"); 
			    	    
			      }else{
			    	  sb.append("\t\t\t<if test=\"reField."+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"!= null\"> \r\n"); 
			      }
			   sb.append("\t\t\tA."+colnames[i]+" AS " +getLowercaseChar(initcap(colnames[i].toLowerCase()))+",\r\n");  
			   sb.append("\t\t</if>\r\n");		   
		   }
       } 
	   sb.append("\t\tid\r\n");	
	   sb.append("\t\tFROM \r\n");
	   sb.append("\t\t\t"+tablename.toLowerCase()+" A \r\n");
	   sb.append("\t\tWHERE  1=1 \r\n");
	   for(int i = 0; i < colnames.length; i++){
		   sb.append("\t\t\t<if test=\"equal."+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"!= null and equal."+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"!= ''\"> \r\n");
		   sb.append("\t\t\t\tAND A."+colnames[i]+"=#{equal."+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"} \r\n");
		   sb.append("\t\t\t</if> \r\n");
	   }
	   for(int i = 0; i < colnames.length; i++){
		   sb.append("\t\t\t<if test=\"like."+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"!= null and like."+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"!= ''\"> \r\n");
		   sb.append("\t\t\t\tAND A."+colnames[i]+" LIKE concat(concat('%',#{like."+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"},'%')) \r\n");
		   sb.append("\t\t\t</if> \r\n");
	   }
	   sb.append("\t\t\t<if test=\"order!= null and order!= ''\"> \r\n");
	    
	   sb.append("\t\t\t\t order by ${order} desc \r\n");
	   sb.append("\t\t\t</if> \r\n");
	   
	   sb.append("\t\t\t<if test=\"limit.page>-1  \"> \r\n");
	   sb.append("\t\t\t\t<if test=\"limit.rows>-1\"> \r\n");
	   sb.append("\t\t\t\t\t LIMIT #{limit.page},#{limit.rows} \r\n");
	   sb.append("\t\t\t\t</if> \r\n");
	   sb.append("\t\t\t</if> \r\n");
	   sb.append("\t\t</select> \r\n");
	   
	   
	   
	   
	   //根据map 条件查询  返回一个总条数
	   sb.append("\r\n");
	   sb.append("\t<!-- 根据  条件 查询单表  分页、模糊、等于、排序、返回字段 返回一个list -->\r\n");
	   sb.append("\t<select id=\"searchTotals\" resultType=\"java.lang.Integer\" >\r\n");
	   sb.append("\t\tSELECT \r\n");
	    
	   sb.append("\t\tcount(*) \r\n");
	   
	   sb.append("\t\tFROM \r\n");
	   sb.append("\t\t\t"+tablename.toLowerCase()+" A \r\n");
	   sb.append("\t\tWHERE  1=1 \r\n");
	   for(int i = 0; i < colnames.length; i++){
		   sb.append("\t\t\t<if test=\"equal."+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"!= null and equal."+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"!= ''\"> \r\n");
		   sb.append("\t\t\t\tAND A."+colnames[i]+"=#{equal."+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"} \r\n");
		   sb.append("\t\t\t</if> \r\n");
	   }
	   for(int i = 0; i < colnames.length; i++){
		   sb.append("\t\t\t<if test=\"like."+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"!= null and like."+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"!= ''\"> \r\n");
		   sb.append("\t\t\t\tAND A."+colnames[i]+" LIKE concat(concat('%',#{like."+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"},'%')) \r\n");
		   sb.append("\t\t\t</if> \r\n");
	   }
	   
	  
	   sb.append("\t\t</select> \r\n");
	   
	   
	   
	   //根据id 物理删除  条件查询  返回一个
	   sb.append("\r\n");
	   sb.append("\t<!-- 根据id物理删除 "+tablename+" -->\r\n");
	   sb.append("\t<delete id=\"delete\" parameterType=\"java.lang.String\">\r\n");
	   sb.append("\t\tDELETE FROM \r\n");
	   sb.append("\t\t\t"+tablename.toLowerCase()+" \r\n");
	   sb.append("\t\tWHERE  \r\n");
	   sb.append("\t\t\tID=#{id} \r\n");
	   sb.append("\t</delete> \r\n");
	   
	   
	   //根据id 逻辑删除  条件查询  返回一个 IS_DEL 
	   sb.append("\r\n");
	   sb.append("\t<!-- 根据id逻辑删除 "+tablename+"  IS_DEL 删除标识 1已删除 0未删除-->\r\n");
	   sb.append("\t<update id=\"put\" parameterType=\"java.lang.String\">\r\n");
	   sb.append("\t\tUPDATE "+tablename+" \r\n");
	   sb.append("\t\t<set>\r\n");
	   sb.append("\t\t\t IS_DEL=1\r\n");
	   sb.append("\t\t</set>\r\n");
	   sb.append("\t\tWHERE  \r\n");
	   sb.append("\t\t\tID=#{id} \r\n");
	   sb.append("\t\t</update> \r\n");
	   
	   
	   
	   //新增 
	   sb.append("\r\n");
	   sb.append("\t<!-- 新增 "+tablename+" -->\r\n");
	   sb.append("\t<insert id=\"add\" parameterType=\""+this.packageOutPath+"."+"dao"+".entity."+initcap(tablename)+"\">\r\n");
	   sb.append("\t\tINSERT INTO "+tablename+" \r\n");
	   sb.append("\t\t<trim prefix=\"(\" suffix=\")\" suffixOverrides=\",\" >\r\n");
	   for(int i = 0; i < colnames.length; i++) { 
		   if(!"id".equals(colnames[i].toLowerCase())  ){
			   if(colTypes[i].equalsIgnoreCase("varchar") || colTypes[i].equalsIgnoreCase("char")   
		                || colTypes[i].equalsIgnoreCase("nvarchar") || colTypes[i].equalsIgnoreCase("nchar")   
		                || colTypes[i].equalsIgnoreCase("text") || colTypes[i].equalsIgnoreCase("tinytext")){
			    	  sb.append("\t\t\t<if test=\""+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"!= null and "+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"!=''\"> \r\n"); 
			    	    
			      }else{
			    	  sb.append("\t\t\t<if test=\""+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"!= null\"> \r\n"); 
			      }
			   sb.append("\t\t\t"+colnames[i]+",\r\n");
			   sb.append("\t\t\t</if> \r\n");
		   }
	   }
	   sb.append("\t\t\tid \r\n");
	   sb.append("\t\t</trim>  \r\n");
	   sb.append("\t\t<trim prefix=\"VALUES(\" suffix=\")\" suffixOverrides=\",\" >\r\n");
	   for(int i = 0; i < colnames.length; i++) { 
		   if(!"id".equals(colnames[i].toLowerCase())){
			   if(colTypes[i].equalsIgnoreCase("varchar") || colTypes[i].equalsIgnoreCase("char")   
		                || colTypes[i].equalsIgnoreCase("nvarchar") || colTypes[i].equalsIgnoreCase("nchar")   
		                || colTypes[i].equalsIgnoreCase("text") || colTypes[i].equalsIgnoreCase("tinytext")){
			    	  sb.append("\t\t\t<if test=\""+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"!= null and "+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"!=''\"> \r\n"); 
			    	    
			      }else{
			    	  sb.append("\t\t\t<if test=\""+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"!= null\"> \r\n"); 
			      }
			   sb.append("\t\t\t#{"+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"},\r\n");
			   sb.append("\t\t\t</if> \r\n");
		   }
	   }
	   sb.append("\t\t\t#{id} \r\n");
	   sb.append("\t\t</trim>  \r\n");
	   sb.append("\t</insert> \r\n");
	  
	   
	   
	   
	   //修改
	   sb.append("\r\n");
	   sb.append("\t<!-- 修改 "+tablename+" -->\r\n");
	   sb.append("\t<update id=\"update\" parameterType=\""+this.packageOutPath+"."+"dao"+".entity."+initcap(tablename)+"\">\r\n");
	   sb.append("\t\tUPDATE "+tablename+" \r\n");
	   sb.append("\t\t<set>\r\n");
	   for(int i = 0; i < colnames.length; i++) { 
		   if(!"id".equals(colnames[i].toLowerCase())){
			    if(colTypes[i].equalsIgnoreCase("varchar") || colTypes[i].equalsIgnoreCase("char")   
		                || colTypes[i].equalsIgnoreCase("nvarchar") || colTypes[i].equalsIgnoreCase("nchar")   
		                || colTypes[i].equalsIgnoreCase("text") || colTypes[i].equalsIgnoreCase("tinytext")){
			    	  sb.append("\t\t\t<if test=\""+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"!= null and "+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"!=''\"> \r\n"); 
			    	    
			      }else{
			    	  sb.append("\t\t\t<if test=\""+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"!= null\"> \r\n"); 
			      }
				   sb.append("\t\t\t"+colnames[i]+"=#{"+getLowercaseChar(initcap(colnames[i].toLowerCase()))+"},\r\n");
				   sb.append("\t\t\t</if> \r\n");  
		   }
		   
	   } 
	   sb.append("\t\tid =id</set>\r\n");
	   sb.append("\t\tWHERE  \r\n");
	   sb.append("\t\t\tID=#{id} \r\n");
	   sb.append("\t</update> \r\n");
	
   }  
   /* 
     * 构造函数 ,实现祖始类
     * entity 实体层 生成
     */  
    public void createEntityMysql() throws SQLException{  
        //创建连接  
        Connection con = null;  
        //查要生成实体类的表  
        con = DriverManager.getConnection(URL,NAME,PASS); 
        String sql="SELECT   column_name,data_type, character_maximum_length,is_nullable,column_comment FROM  Information_schema. COLUMNS WHERE TABLE_SCHEMA = '"+dbName+"' AND table_Name = '"+tablename+"'";
        System.out.println("查询sql："+sql);
        ResultSet	rs=con.createStatement().executeQuery(sql);
		rs.last();//移到最后一行
        int  count = rs.getRow();
        rs.beforeFirst();//移到初始位置
            
        colnames = new String[count];  
        colTypes = new String[count];  
        colremarks = new String[count]; 
        colSizes=new Long[count];
        colisnull=new String[count];
        int i=0;
        while (rs.next()) {
        	//获取列列名
        	colnames[i] = rs.getString("COLUMN_NAME");
            //备注
        	colremarks[i] = rs.getString("column_comment");
            //列类型
           colTypes[i] = rs.getString("data_type"); 
           //长度
           colSizes[i]=  rs.getLong("character_maximum_length");
           //是否为必填
           colisnull[i]= rs.getString("is_nullable");
           i++;
        } 

            String content = parse(colnames,colTypes,colremarks);   
            try {  
                File directory = new File("");  
               // String path=this.getClass().getResource("").getPath();  
                String outputPath = directory.getAbsolutePath()+ "/src/main/java/"+ packageOutPath.replace('.', '/')+"/"+initcap(tablename).toLowerCase()+"/entity/"+initcap(tablename)+ ".java";  
                File file3 = new File(directory.getAbsolutePath()+ "/src/main/java/"+ packageOutPath.replace('.', '/')+"/"+initcap(tablename).toLowerCase());
                File file4 = new File(directory.getAbsolutePath()+ "/src/main/java/"+ packageOutPath.replace('.', '/')+"/"+initcap(tablename).toLowerCase()+"/entity/");
                if (file3.mkdir()) {
                    System.out.println("多级层文件夹下文件创建成功！创建了的文件为:" + file3.getAbsolutePath() + ",上级文件为:" + file3.getParent());
                }
                if (file4.mkdir()) {
                	System.out.println("多级层文件夹下文件创建成功！创建了的文件为:" + file3.getAbsolutePath() + ",上级文件为:" + file3.getParent());
                }
                FileWriter fw = new FileWriter(outputPath);  
                PrintWriter pw = new PrintWriter(fw);  
                pw.println(content);  
                pw.flush();  
                pw.close();  
            } catch (IOException e) {  
                e.printStackTrace();  
            }  
    }  

   /**
	     * web html  层 
	     * 生成简单的html 实现 查分页  添加 修改 删除
	     *  /**
	     * @Title: MakeHtml 
	     * @Description: 创建html
	     * @return void    返回类型 
	     * @throws
	     * **/
	    public void createWebHtml(){
	 	     try {  
	              File directory = new File("");  
	            //  String path=this.getClass().getResource("").getPath();  
	              String disrPath = directory.getAbsolutePath()+ "/src/main/resources/"+ htmlAddress+"/"+initcap(tablename).toLowerCase();  
	              String filePath = directory.getAbsolutePath()+ "/src/main/resources/templates/common/template.html";  
	              File file3 = new File(disrPath);
	              if (file3.mkdir()) {
	                  System.out.println("多级层文件夹下文件创建成功！创建了的文件为:" + file3.getAbsolutePath() + ",上级文件为:" + file3.getParent());
	              }
	              String fileName=initcap(tablename).toLowerCase();
	              List<String> list =new ArrayList<String>();
	              
	              list.add("/system/sysDept/treeyfw");// 替换replace0 树结构的url 地址
	              list.add(initcap(tablename).toLowerCase());// 替换replace1 列表请求url 地址
	             
	              list.add(replace2().toString());// html中 #replace2 位置替换
	              list.add(replace3().toString());// html中 #replace3 位置替换
	              list.add("/"+initcap(tablename).toLowerCase()+"/saveorupdate");// html中 #replace4 位置替换
	              list.add("/"+initcap(tablename).toLowerCase()+"/saveorupdate");// html中 #replace5位置替换
	              list.add("/"+initcap(tablename).toLowerCase()+"/delete");// html中 #replace6位置替换
	              list.add("/"+initcap(tablename).toLowerCase()+"/selectById");// html中 #replace7位置替换
	             
	              CreateHtmlUtils.MakeHtml(filePath, disrPath, fileName, list);
	            
	 	     } catch (Exception e) {  
	              e.printStackTrace();  
	          }  
	    }
	   

}