package com.hywa.map.common.strategy.importing;

import org.springframework.stereotype.Component;
import org.springframework.web.multipart.MultipartFile;

import java.util.HashMap;
import java.util.Map;

/***
 * @Author: vic
 * 用于提供下载模板的工厂类
 */
@Component
public class ImportExcelFactory {

    private static Map<String, ImportExcel> DOWNLOADMAP = new HashMap<>();

    private ImportExcelFactory() {
    }

    private static final ImportExcel EMPTY = new ImportExcel() {
        @Override
        public void uploadArtificialCollectExcel(String type, String userId, MultipartFile file) {

        }
    };

    //获取
    public static ImportExcel getImportExcel(String state) {
        ImportExcel result = DOWNLOADMAP.get(state);
        return result == null ? EMPTY : result;
    }

    //注册
    public static void registerImportExcel(String state, ImportExcel o) {
        DOWNLOADMAP.put(state, o);
    }


}
