package com.hywa.map.common.utils;

import java.util.*;

public class ListUtils {

    /**
     * 根据map中的某个key 去除List中重复的map
     *
     * @param list
     * @param mapKey
     * @return
     */
    public static List<Map<String, String>> removeRepMapByKey(List<Map<String, String>>
                                                                      list, String mapKey) {
        if (list == null || list.size() <= 0) {
            return null;
        }
        //把list中的数据转换成msp,去掉同一id值多余数据，保留查找到第一个id值对应的数据
        List<Map<String, String>> listMap = new ArrayList<>();
        Map<String, Map> msp = new HashMap<>();
        for (int i = list.size() - 1; i >= 0; i--) {
            Map map = list.get(i);
            String id = (String) map.get(mapKey);
            map.remove(mapKey);
            msp.put(id, map);
        }
        //把msp再转换成list,就会得到根据某一字段去掉重复的数据的List<Map>
        Set<String> mspKey = msp.keySet();
        for (String key : mspKey) {
            Map newMap = msp.get(key);
            newMap.put(mapKey, key);
            listMap.add(newMap);
        }
        return listMap;
    }

    /**
     * 根据map中的某个key 排序
     *
     * @param list
     * @param sortKey
     * @param sortType 1-升序 2-降序
     * @return
     */
    public static List<Map<String, String>> sortMapByKey(List<Map<String, String>>
                                                                 list, String sortKey, int sortType) {
        Collections.sort(list, new Comparator<Map<String, String>>() {
            public int compare(Map<String, String> o1, Map<String, String> o2) {
                Integer name1 = Integer.valueOf(o1.get(sortKey).toString());//name1是从list里面拿出来的一个
                Integer name2 = Integer.valueOf(o2.get(sortKey).toString()); //name1是从list里面拿出来的第二个name
                return 1 == sortType ? name1.compareTo(name2) : name2.compareTo(name1);
            }
        });
        return list;
    }
}
