package com.hywa.map.common.utils;

import java.util.List;

public class PageUtils {

    public static List<?> paging(List<?> List, int pageNo, int pageSize, int total) {
        pageNo = pageNo == 0 ? 1 : pageNo;

        Integer requestCount = (int) Math.ceil((double) total / (double) pageSize);
        if (total <= pageSize) {
            return List;
        }

        for (int i = 0; i < requestCount; i++) {
            Integer fromIndex = i * pageSize;
            int toIndex = Math.min(total, (i + 1) * pageSize);

            List<?> subList = List.subList(fromIndex, toIndex);
            if (i + 1 == pageNo) {
                return subList;
            }
            if (toIndex == total) {
                return subList;
            }
        }
        return null;
    }
}
