package com.hywa.map.common.utils;

import com.opencsv.CSVReader;
import com.opencsv.CSVReaderBuilder;
import org.apache.commons.io.FileUtils;
import org.apache.commons.io.LineIterator;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

/**
 * 文件工具类
 *
 * @author hywa
 * @version 1.0
 */
public class TextFileUtils {
    private static Logger logger = LoggerFactory.getLogger(TextFileUtils.class);

    /**
     * 将list数据写入文件
     *
     * @param list     数据集合
     * @param fileName 文件名称
     * @return String 0-写文件成功 1-写文件失败
     */
    public static boolean writeFile(ArrayList<String> list, String fileName, boolean isAppend) {
        File file = new File(fileName);
        try {
            FileUtils.writeLines(file, "utf-8", list, isAppend);
        } catch (IOException e) {
            return false;
        }
        return true;
    }

    /**
     * 读文件数据到list
     *
     * @param fileName 文件名称
     * @return LineIterator 数据集合
     */
    public static LineIterator readFile(String fileName,String encoding) {
        File file = new File(fileName);
        LineIterator iterator = null;
        try {
            iterator = FileUtils.lineIterator(file, encoding);
        } catch (IOException e) {

        }
        return iterator;
    }

    /**
     * 删除文件
     *
     * @param fileName 文件名称
     * @return
     */
    public static boolean deleteFile(String fileName) {
        File file = new File(fileName);
        return FileUtils.deleteQuietly(file);
    }

    public static void main(String[] args) {
        ArrayList<String> list = new ArrayList<>();
        LineIterator iterator = readFile("C:\\Users\\Administrator\\Desktop\\农投品监管平台\\导入数据\\采购记录.csv","utf-8");
        while(iterator.hasNext())
        {
            String newLine="";
            String oneLine=iterator.nextLine();
            String[] lineArray = oneLine.split("\\,");
            for(int i=0;i<lineArray.length;i++){
                lineArray[i]= StringUtils.isEmpty(lineArray[i])?"this is null":lineArray[i];
                newLine=newLine+","+lineArray[i];
            }
            System.out.println(Arrays.toString(lineArray));
            list.add(newLine.substring(1));
        }
        iterator.close();
        list.remove(0);
        //writeFile( list, "C:\\Users\\Administrator\\Desktop\\农投品监管平台\\导入数据\\采购记录jinyin.csv", false);
    }
}
