package com.hywa.map.config;

import lombok.Getter;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Getter
@Component
public class EnvProperties {
    /**
     * 超级用户id
     */
    @Value("${adminId}")
    private String adminId;
    /**
     * 超级角色id
     */
    @Value("${adminRoleId}")
    private String adminRoleId;
    @Value("${local.http.url}")
    private String localHttp;

    /**
     * csv文件上传路径
     */
    @Value("${csv.file.path}")
    private String csvFilePath;
    /**
     * csv文件下载路径
     */
    @Value("${csv.download.url}")
    private String csvDownloadUrl;
    /**
     * csv文件mysql数据库路径
     */
    @Value("${mysql.data.file.path}")
    private String mysqlDataFilePath;
    /**
     * 3des密钥
     */
    @Value("${three.des.key}")
    private String threeDesKey;
    /**
     * 文件统一下载路径
     */
    @Value("${public.file.download.url}")
    private String pubFileDownloadUrl;
    /**
     * 大屏缩略图保存目录
     */
    @Value("${map.picture.path}")
    private String mapPicturePath;
    /**
     * 上传文件统一保存目录
     */
    @Value("${common.file.path}")
    private String comFilePath;
    /**
     * 上传文件统一下载路径
     */
    @Value("${common.file.download.url}")
    private String comFileDownloadUrl;
    /**
     * 萤石开放平台appKey
     */
    @Value("${ys.open.appKey}")
    private String ysAppkey;
    /**
     * 萤石开放平台secret
     */
    @Value("${ys.open.secret}")
    private String ysSecret;
    /**
     * 萤石开放平台访问地址
     */
    @Value("${ys.server.url}")
    private String ysServerUrl;
    /**
     * 物联网访问路径
     */
    @Value("${iot.server.url}")
    private String iotServerUrl;

}
