package com.hywa.map.config.interceptor;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Component;

import java.util.Set;

@Component
public class AuthService {

    @Autowired
    private StringRedisTemplate redis;

    public Set<String> getPermission(String userId) {
        //redis中获取用户权限列表
        return redis.opsForSet().members(userId+"_authority");
    }

    public boolean isAuth(String userId,String servletPath) {
        //redis中获取用户权限列表
       return redis.opsForSet().isMember(userId+"_authority", servletPath);
    }
}
