package com.hywa.map.config.interceptor;

import com.hywa.map.common.utils.StringUtils;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Component
public class UserAuthContext implements AuthStrategy {

    @Autowired
    private AuthService authService;
    @Value("${user.check.auth}")
    private String isCheck;

    @Override
    public boolean executeAuth(String userId, String servletPath) {
        if (!"1".equals(isCheck)) {
            return true;
        }
        //用户ID为空，不允许通过，直接返回false
        if (StringUtils.isEmpty(userId)) {
            return false;
        }
        //如果用户拥有该接口所属模块权限则返回true,否则false
        return authService.isAuth(userId, servletPath);
    }

}
