package com.hywa.map.controller.log;

import com.hywa.map.representation.*;
import com.hywa.map.service.log.LogService;
import com.hywa.map.service.login.MenuService;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

@Api(tags = "系统日志")
@RestController
@RequestMapping("log")
public class LogController {

    @Autowired
    LogService logService;

    @Autowired
    private MenuService menuService;

    @RequestMapping(value = "/queryFuncName", method = RequestMethod.GET)
    public ResponseEntity<ResponseBase> queryFuncName() {
        ResponseBase menuRepResponseBase = new ResponseBase<>();
        menuRepResponseBase.success();
        menuRepResponseBase.setRetBody(menuService.searchSubMenu());
        return new ResponseEntity<>(menuRepResponseBase, HttpStatus.OK);
    }

    @RequestMapping(value = "/queryAll", method = RequestMethod.GET)
    public ResponseEntity<ResponseBase<LogReps>> findByName(@RequestParam(required = false) String menuName,
                                                            @RequestParam(required = false) String userName,
                                                            @RequestParam(required = false) String beginDate,
                                                            @RequestParam(required = false) String endDate,
                                                            @RequestParam(defaultValue = "1") Integer pageNo,
                                                            @RequestParam(defaultValue = "10") Integer pageSize) {
        ResponseBase<LogReps> responseBase = new ResponseBase<>();
        responseBase.success().setRetBody(logService.queryAll(pageNo, pageSize, menuName, userName, beginDate, endDate));
        responseBase.success();
        return new ResponseEntity<>(responseBase, HttpStatus.OK);
    }
}


