package com.hywa.map.controller.login.validate;

import com.hywa.map.common.ConstantPool;
import com.hywa.map.common.enums.CommonEnum;
import com.hywa.map.common.utils.SpringContext;
import com.hywa.map.config.validation.Validator;
import com.hywa.map.dao.entity.User;
import com.hywa.map.dao.mapper.UserMapper;
import com.hywa.map.representation.LoginInfoRep;
import com.hywa.map.representation.ResponseBase;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;

import java.util.Map;
import java.util.Objects;

/**
 * @Author: vic
 * 校验登录状态
 */
public class StateValidationValidate extends Validator{
    @Override
    public ResponseEntity<ResponseBase> validate(Object... t) {
        String menuName="用户登录-登录";
        ResponseBase responseBase = new ResponseBase<>();
        LoginInfoRep loginInfoRep = (LoginInfoRep) t[0];
            String userName=loginInfoRep.getUserName();
        if(Objects.equals(userName,"admin")){
            return null;
        }
        UserMapper userMapper = (UserMapper) SpringContext.getBean("userMapper");

        User user = userMapper.selectByUserName(userName);
        if(null==user){
            responseBase.setRetHead(CommonEnum.USER_UNREGISTERED_ERROR.getIndex(),CommonEnum.USER_UNREGISTERED_ERROR.getValue());
            return new ResponseEntity<>(responseBase, HttpStatus.OK);
        }
        if (Objects.equals(ConstantPool.DISAABLE,user.getStatus())){
            responseBase.setRetHead(CommonEnum.THE_ACCOUNT_IS_BANNED.getIndex(),CommonEnum.THE_ACCOUNT_IS_BANNED.getValue());
            return new ResponseEntity<>(responseBase, HttpStatus.OK);
        }

        Map<String, Integer> examine = userMapper.examine(userName);

        if (null==examine){
            responseBase.setRetHead(CommonEnum.USER_UNREGISTERED_ERROR.getIndex(), CommonEnum.USER_UNREGISTERED_ERROR.getValue());
            return new ResponseEntity<>(responseBase, HttpStatus.OK);
        }

        switch (examine.get("roleInfo")){
            case 0:
                break;
            case 1:
                responseBase.setRetHead(CommonEnum.ABNORMAL_ACCOUNT.getIndex(),"该账号所属角色被锁定");
                return new ResponseEntity<>(responseBase, HttpStatus.OK);
            case 2:
                responseBase.setRetHead(CommonEnum.ABNORMAL_ACCOUNT.getIndex(),"该账号所属角色被禁用");
                return new ResponseEntity<>(responseBase, HttpStatus.OK);
            default:
                break;

        }
        return null;
    }

}
