package com.hywa.map.controller.use;

import com.hywa.map.common.utils.DateUtils;
import com.hywa.map.common.utils.FileUtils;
import com.hywa.map.config.EnvProperties;
import com.hywa.map.representation.ComboxReps;
import com.hywa.map.representation.ResponseBase;
import com.hywa.map.representation.UseReps;
import com.hywa.map.service.use.UseService;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.UnsupportedEncodingException;
import java.util.Date;

/**
 * t_mon_dealer_invent  对应Controller 实现类
 *
 * @author hywa
 * @create by 2019-03-04 13:49:14
 */
@Slf4j
@Api(tags = "使用记录")
@RestController
@RequestMapping("/use")
public class UseController {

    @Autowired
    private UseService useService;
    @Autowired
    EnvProperties envProperties;

    @RequestMapping(value = "/findGoodsType", method = RequestMethod.GET)
    public ResponseEntity<ResponseBase> findGoodsType() {
        ResponseBase<ComboxReps> responseBase = new ResponseBase<>();
        responseBase.success().setRetBody(useService.selectGoodsType());
        return new ResponseEntity<>(responseBase, HttpStatus.OK);
    }

    @RequestMapping(value = "/findAll", method = RequestMethod.GET)
    public ResponseEntity<ResponseBase> findByParam(@RequestParam(defaultValue = "1") int pageNo,
                                                    @RequestParam(defaultValue = "10") int pageSize,
                                                    @RequestParam(required = false) String queryParam,
                                                    @RequestParam(required = false) String year,
                                                    @RequestParam(required = false) String month,
                                                    @RequestParam(required = false) String goodsType,
                                                    @RequestParam(required = false) String warehouse) {
        ResponseBase<UseReps> responseBase = new ResponseBase<>();
        responseBase.success().setRetBody(useService.selectAll(pageNo, pageSize, queryParam, year, month, goodsType,null));
        return new ResponseEntity<>(responseBase, HttpStatus.OK);
    }
}