package com.hywa.map.dao.entity;

import java.io.Serializable;
import java.util.Date;

/**
 * t_web_notice 实体类 对应表名
 *
 * @author hywa
 * @create by 2019-02-18 15:12:07
 */
public class Notice implements Serializable {

    private static final long serialVersionUID = 1L;
    /**
     * 主键
     */
    private String id;
    /**
     * 标题
     */
    private String title;
    /**
     * 内容
     */
    private String content;
    /**
     * 类型 1-新闻 2-通知 3-公告 9-红黑榜
     */
    private short noticeType;
    /**
     * 子类型
     */
    private String subType;
    /**
     * 子类型名称
     */
    private String subTypeName;
    /**
     * 状态 0-未发布 1-已发布 2-撤回
     */
    private short state;
    /**
     * 发布时间
     */
    private Date publishTime;
    /**
     * 发布人
     */
    private String publishUser;
    /**
     * 批次
     */
    private String batchNo;
    /**
     * 是否删除 0-未删除 1-已删除
     */
    private int isDel;
    /**
     * 创建人
     */
    private String createUser;
    /**
     * 创建时间
     */
    private Date createDate;
    /**
     * 修改人
     */
    private String updateUser;
    /**
     * 修改时间
     */
    private Date updateDate;
    /**
     * 来源
     */
    private String origin;

    public Notice(String id) {
        this.setId(id);
    }

    public Notice() {
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getId() {
        return id;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getTitle() {
        return title;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public String getContent() {
        return content;
    }

    public void setNoticeType(short noticeType) {
        this.noticeType = noticeType;
    }

    public short getNoticeType() {
        return noticeType;
    }

    public void setSubType(String subType) {
        this.subType = subType;
    }

    public String getSubType() {
        return subType;
    }

    public void setState(short state) {
        this.state = state;
    }

    public short getState() {
        return state;
    }

    public void setPublishTime(Date publishTime) {
        this.publishTime = publishTime;
    }

    public Date getPublishTime() {
        return publishTime;
    }

    public void setPublishUser(String publishUser) {
        this.publishUser = publishUser;
    }

    public String getPublishUser() {
        return publishUser;
    }

    public void setBatchNo(String batchNo) {
        this.batchNo = batchNo;
    }

    public String getBatchNo() {
        return batchNo;
    }

    public void setIsDel(int isDel) {
        this.isDel = isDel;
    }

    public int getIsDel() {
        return isDel;
    }

    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }

    public String getCreateUser() {
        return createUser;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    public Date getCreateDate() {
        return createDate;
    }

    public void setUpdateUser(String updateUser) {
        this.updateUser = updateUser;
    }

    public String getUpdateUser() {
        return updateUser;
    }

    public void setUpdateDate(Date updateDate) {
        this.updateDate = updateDate;
    }

    public Date getUpdateDate() {
        return updateDate;
    }

    public String getOrigin() {
        return origin;
    }

    public void setOrigin(String origin) {
        this.origin = origin;
    }

    public String getSubTypeName() {
        return subTypeName;
    }

    public void setSubTypeName(String subTypeName) {
        this.subTypeName = subTypeName;
    }
}

