package com.hywa.map.dao.mapper;

import com.hywa.map.dao.entity.AgriData;
import com.hywa.map.dao.entity.SysArea;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;


/**
 * t_agri_data  对应mapperInterface 接口类
 *
 * @author hywa
 * @create by 2019-05-06 14:18:17
 */
@Mapper
public interface AgriDataMapper {
    /*
     * 查询农业产业信息
     */
    AgriData select(@Param("dataType") String dataType, @Param("posId") String posId);

    /*
     * 查询农业产业信息
     */
    AgriData selectById(@Param("id") String id);

    /*
     * 查询区域信息
     */
    SysArea selectBySn(@Param("sn") String sn);

    /*
     * 查询区域信息
     */
    List<SysArea> selectSubAreaBySn(@Param("sn") String sn);
}

