package com.hywa.map.dao.mapper;

import com.hywa.map.dao.entity.AgriGroupItem;
import com.hywa.map.representation.AgriGroupDetails;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * t_agri_group_detail  对应mapperInterface 接口类
 *
 * @author hywa
 * @create by 2019-05-07 15:30:17
 */
@Mapper
public interface AgriGroupDetailMapper {
    /*
     * 根据组别子项查询农业地标统计信息
     */
    List<AgriGroupDetails> select(@Param("refId") String refId,@Param("parentId") String parentId);
    /*
     * 根据id获取条目别名
     */
    AgriGroupItem selectAlias(@Param("id") String id);
    /*
     * 根据组别查询农业地标统计信息
     */
    List<AgriGroupDetails> selectByGroupId(@Param("refId") String refId,@Param("parentId") String parentId);
    /*
     * 根据组别、区域id查询农业地标统计信息
     */
    List<AgriGroupDetails> selectByGroupIdAndAreaId(@Param("refId") String refId,@Param("parentId") String parentId);
}

