package com.hywa.map.dao.mapper;

import com.hywa.map.dao.entity.AreaData;
import com.hywa.map.dao.entity.Combox;
import com.hywa.map.dao.entity.SysArea;
import com.hywa.map.representation.AreaDataPriceRep;
import com.hywa.map.representation.AreaDataRep;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * t_area_data  对应mapperInterface 接口类
 *
 * @author hywa
 * @create by 2019-11-15 13:44:19
 */
@Mapper
public interface AreaDataMapper {
    /*
     * 新增
     */
    int add(AreaData entity);
    /*
     * 逻辑删除
     */
    int put(@Param("id") String id, @Param("updateUser") String updateUser);
    /*
     * 是否应用于大屏 0-否 1-是
     */
    int updateIsShow(@Param("id") String id, @Param("updateUser") String updateUser, @Param("isShow") String isShow);
    /*
     * 设置同类型同区域同时间是否应用于大屏为0
     */
    int updateOther(AreaData entity);
    /*
     * 批量新增区域数据
     */
    int insertAreaDataBatch(List<Combox> comboxes);

    /*
     * 查询所有区域数据信息
     */
    List<AreaDataRep> selectAll(@Param("areaName") String areaName, @Param("dataType") String dataType, @Param("dataName") String dataName, @Param("dataTime") String dataTime);
    /*
     * 根据id查询区域数据信息
     */
    AreaDataRep selectById(@Param("id") String id);
    /*
     * 根据id查询区域数据明细信息
     */
    List<AreaData> selectDetailByDataId(@Param("dataId") String dataId);
    /*
     * 根据区域名称,数据类型查询区域数据信息,用于大屏显示
     */
    AreaDataRep selectShow(@Param("areaName") String areaName, @Param("dataType") String dataType);
    /*
     * 根据区域名称,数据类型查询区域数据信息,用于大屏显示,适用于没有区域id的情况
     */
    AreaDataRep selectDisplay(@Param("areaName") String areaName, @Param("dataType") String dataType);
    /*
     * 查询品种价格升降百分比等信息 益农社
     */
    List<AreaDataPriceRep> selectPrice(@Param("beginDate") String beginDate, @Param("endDate") String endDate, @Param("cateName") String cateName, @Param("areaName") String areaName);
    /*
     * 查询品种价格升降百分比等信息 前端大屏幕
     */
    List<AreaDataPriceRep> selectPriceRate(@Param("beginDate") String beginDate, @Param("endDate") String endDate, @Param("cateName") String cateName, @Param("areaName") String areaName, @Param("dataId") String dataId);
    /*
     * 根据id编码统计专题记录数
     */
    int countBySourceId(@Param("sourceId") String sourceId);
    /*
     * 根据地理名称获取经纬度
     */
    SysArea selectPosByName(@Param("posName") String posName, @Param("posAliasName") String posAliasName, @Param("porvinceName") String porvinceName, @Param("cityName") String cityName, @Param("countyName") String countyName );
}

