package com.hywa.map.dao.mapper;
import com.hywa.map.dao.entity.Branch;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
* branch  对应mapperInterface 接口类
* @create by 2019-02-14 09:13:52
* @author hywa
*/ 
@Mapper 
public interface BranchMapper {
    /*
     * 新增
     */
    int add(Branch entity);

    /*
     * 修改
     */
    int update(Branch entity);

    /*
     * 逻辑删除
     */
    int put(@Param("id") String id, @Param("updateUser") String updateUser);
    /*
     * 物理删除
     */
    int delete(@Param("id") String id);
    /*
     * 根据名称统计记录数
     */
    int countByName(@Param("branchName") String branchName, @Param("id") String id);

    /*
     * 根据id编码统计下级记录数
     */
    int countById(@Param("branchId") String branchId);

    /*
     * 根据名称、电话查询
     */
    List<Branch> select(@Param("queryParam") String queryParam);
    /*
     * 查询所有机构信息
     */
    List<Branch> selectAll();
    /*
     * 根据id查询
     */
    Branch selectById(@Param("id") String id);
    /*
     * 根据id编码统计所属用户记录数
     */
    int countUserById(@Param("branchId") String branchId);

}

