package com.hywa.map.dao.mapper;

import com.hywa.map.dao.entity.CsvFile;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * t_topic_db  对应mapperInterface 接口类
 *
 * @author hywa
 * @create by 2019-05-13 15:13:54
 */
@Mapper
public interface CsvMapper {
    /*
     * 查询数据
     */
    List<Map<String, String>> selectByTableName(@Param("tableName") String tableName);

    /*
     * 查询表字段
     */
    List<Map<String, String>> selectFieldByTableName(@Param("tableName") String tableName);

    /**
     * 创建表
     */
    void createTable(@Param("sql") String sql);
    /**
     * 查询csv文件与数据库表对应关系
     */
    CsvFile selectFile(@Param("id") String id,@Param("fileName") String fileName);
    /**
     * 创建csv文件与数据库表对应关系
     */
    int addFile(CsvFile entity);
    /*
     * 修改csv文件与数据库表对应关系
     */
    int updateFile(@Param("id") String id, @Param("updateUser") String updateUser);
}

