package com.hywa.map.dao.mapper;

import com.hywa.map.dao.entity.DamInfo;
import com.hywa.map.representation.DamDetailInfoRep;
import com.hywa.map.representation.DamInfoRep;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * t_dam_info  对应mapperInterface 接口类
 *
 * @author hywa
 * @create by 2019-11-01 16:05:48
 */
@Mapper
public interface DamInfoMapper {
    /*
     * 新增
     */
    int add(DamInfo entity);
    /*
     * 修改
     */
    int update(DamInfo entity);
    /*
     * 逻辑删除
     */
    int put(@Param("id") String id, @Param("updateUser") String updateUser);
    /*
     * 修改状态 0-启用 1-禁用
     */
    int updateState(@Param("id") String id, @Param("updateUser") String updateUser, @Param("state") String state);
    /*
     * 查询所有坝区信息
     */
    List<DamInfoRep> selectAll(@Param("areaCode") String areaCode, @Param("damName") String damName,@Param("state") String state,@Param("areaName") String areaName);
    /*
     * 根据id查询坝区信息
     */
    DamDetailInfoRep selectById(@Param("id") String id);
}

