package com.hywa.map.dao.mapper;

import com.hywa.map.dao.entity.DbCsv;
import com.hywa.map.dao.entity.DbLib;
import com.hywa.map.dao.entity.DbSource;
import com.hywa.map.representation.DbRep;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * t_db_source  对应mapperInterface 接口类
 *
 * @author hywa
 * @create by 2019-08-28 15:14:43
 */
@Mapper
public interface DbSourceMapper {
    /*
     * 新增数据源
     */
    int addSource(DbSource entity);

    /*
     * 新增数据库
     */
    int addLib(DbLib entity);

    /*
     * 新增csv文件
     */
    int addCsv(DbCsv entity);
    /*
     * 根据名称统计记录数
     */
    int countByName(@Param("sourceName") String sourceName, @Param("id") String id);
    /*
     * 编辑数据源
     */
    int updateSource(DbSource entity);

    /*
     * 编辑数据库
     */
    int updateLib(DbLib entity);

    /*
     * 编辑csv文件
     */
    int updateCsv(DbCsv entity);
    /*
     * 逻辑删除
     */
    int put(@Param("id") String id, @Param("updateUser") String updateUser);
    /*
     * 根据id编码统计关联数据记录数
     */
    int countRefById(@Param("id") String id);
    /*
     * 根据名称、类型查询
     */
    List<DbRep> select(@Param("sourceType") String sourceType, @Param("sourceName") String sourceName);
    /*
     * 根据id查询
     */
    DbRep selectById(@Param("id") String id);
}

