package com.hywa.map.dao.mapper;

import com.hywa.map.dao.entity.*;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;


/**
* t_sys_depart  对应mapperInterface 接口类
* @create by 2019-02-14 15:50:31
* @author hywa
*/ 
@Mapper 
public interface DepartMapper {
    /*
     * 新增
     */
    int add(Depart entity);
    /*
     * 逻辑删除
     */
    int put(@Param("id") String id, @Param("updateUser") String updateUser);
    /*
     * 查询单位信息
     */
    Depart select();
    /*
     * 查询联系人信息
     */
    List<Contact> selectContact(@Param("departId") String departId);
    /*
     * 批量增加联系人
     */
    void insertContact(List<Contact> contactKeys);
    /*
     * 物理删除联系人
     */
    int deleteContact(@Param("departId") String departId);
    /*
     * 物理删除单位基本信息
     */
    int delete(@Param("id") String id);
    /*
     * 查询省信息
     */
    List<Province> selectProvince();
    /*
     * 查询市信息
     */
    List<City> selectCity(@Param("provinceId") String provinceId);
    /*
     * 查询县信息
     */
    List<County> selectCounty(@Param("cityId") String cityId);
    /*
     * 查询镇信息
     */
    List<Town> selectTown(@Param("countyId") String countyId);
    /*
     * 查询村信息
     */
    List<Village> selectVillage(@Param("townId") String townId);
}

