package com.hywa.map.dao.mapper;

import com.hywa.map.dao.entity.Combox;
import com.hywa.map.dao.entity.Dict;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
* t_sys_dict  对应mapperInterface 接口类
* @create by 2019-02-15 09:56:54
* @author hywa
*/ 
@Mapper 
public interface DictMapper {
    /*
     * 根据类型统计记录数
     */
    int countByType(@Param("dictType") String dictType,@Param("id") String id);
    /*
     * 根据编码统计记录数
     */
    int countByCode(@Param("dictCode") String dictCode,@Param("id") String id);
    /*
     * 新增
     */
    int add(Dict entity);
    /*
     * 修改
     */
    int update(Dict entity);
    /*
     * 根据类型、编码查询
     */
    List<Dict> select(@Param("queryParam") String queryParam);
    /*
     * 根据id查询
     */
    Dict selectById(@Param("id") String id);
    /*
     * 根据id统计字典值记录数
     */
    int countByDictId(@Param("dictId") String dictId);
    /*
     * 物理删除
     */
    int delete(@Param("id") String id);
    /*
     * 根据类型、编码查询
     */
    List<Dict> selectVal(@Param("dictId") String dictId,@Param("queryParam") String queryParam);
    /*
     * 新增字典值
     */
    int insertVal(Dict entity);
    /*
     * 根据值统计记录数
     */
    int countByVal(@Param("dictName") String dictName,@Param("dictId") String dictId,@Param("id") String id);
    /*
     * 根据序号统计记录数
     */
    int countBySeq(@Param("dictSeq") String dictSeq,@Param("dictId") String dictId,@Param("id") String id);
    /*
     * 根据id查询字典值
     */
    Dict selectValById(@Param("id") String id);
    /*
     * 修改字典值
     */
    int updateVal(Dict entity);
    /*
     * 物理删除字典值
     */
    int deleteVal(@Param("id") String id);
    /*
     * 根据类型、编码查询
     */
    List<Dict> selectValByCode(@Param("dictCode") String dictCode);
    /*
     * 根据id查询
     */
    Dict selectValByName(@Param("dictName") String dictName,@Param("dictCode") String dictCode);
    /*
     * 根据id查询
     */
    List<Dict> selectValByList(@Param("list") List<Combox> itemKeys);
}

