package com.hywa.map.dao.mapper;

import com.hywa.map.dao.entity.ExpertInfo;
import com.hywa.map.representation.ExpertInfoRep;
import com.hywa.map.representation.MapExpertListRep;
import com.hywa.map.representation.MapExpertStatisRep;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * t_expert_info  对应mapperInterface 接口类
 *
 * @author hywa
 * @create by 2019-10-31 14:32:05
 */
@Mapper
public interface ExpertInfoMapper {
    /*
     * 新增
     */
    int add(ExpertInfo entity);

    /*
     * 修改
     */
    int update(ExpertInfo entity);

    /*
     * 逻辑删除
     */
    int put(@Param("id") String id, @Param("updateUser") String updateUser);

    /*
     * 修改状态 0-启用 1-禁用
     */
    int updateState(@Param("id") String id, @Param("updateUser") String updateUser, @Param("state") String state);

    /*
     * 查询所有专家信息
     */
    List<ExpertInfoRep> selectAll(@Param("areaCode") String areaCode, @Param("expertName") String expertName, @Param("typeId") String typeId);

    /*
     * 根据id查询专家信息
     */
    ExpertInfoRep selectById(@Param("id") String id);

    /*
     * 根据专家类型统计专家信息
     */
    List<MapExpertStatisRep> selectStatis(@Param("typeId") String typeId);

    /*
     * 根据专家类型查询专家信息
     */
    List<MapExpertListRep> selectByTypeId(@Param("typeId") String typeId,@Param("areaName") String areaName);
    /*
     * 根据坝区id查询专家信息
     */
    List<MapExpertListRep> selectByDamId(@Param("damId") String damId,@Param("typeId") String typeId);

}

