package com.hywa.map.dao.mapper;

import com.hywa.map.dao.entity.Combox;
import com.hywa.map.dao.entity.MapInfo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * t_map_info  对应mapperInterface 接口类
 *
 * @author hywa
 * @create by 2019-09-18 13:36:13
 */
@Mapper
public interface MapInfoMapper {
    /*
     * 新增
     */
    int add(MapInfo entity);
    /*
     * 更新
     */
    int update(MapInfo entity);
    /*
     * 根据名称统计记录数
     */
    int countByName(@Param("mapName") String mapName, @Param("id") String id);
    /*
     * 逻辑删除
     */
    int put(@Param("id") String id, @Param("updateUser") String updateUser);
    /*
     * 更新状态
     */
    int updateState(@Param("id") String id, @Param("updateUser") String updateUser, @Param("state") String state);
    /*
     * 根据名称查询
     */
    List<MapInfo> select(@Param("mapName") String mapName);
    /*
     * 根据id查询
     */
    MapInfo selectById(@Param("id") String id);
    /*
     * 查询套用框架
     */
    List<Combox> selectTemplate();
}

