package com.hywa.map.dao.mapper;

import com.hywa.map.dao.entity.Menu;
import com.hywa.map.dao.entity.MenuExample;
import java.util.List;
import org.apache.ibatis.annotations.Param;

public interface MenuMapper {

    int countByExample(MenuExample example);

    int deleteByExample(MenuExample example);

    int deleteByPrimaryKey(String id);

    int insert(Menu record);

    int insertSelective(Menu record);

    List<Menu> selectByExample(MenuExample example);

    Menu selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") Menu record,
            @Param("example") MenuExample example);

    int updateByExample(@Param("record") Menu record, @Param("example") MenuExample example);

    int updateByPrimaryKeySelective(Menu record);

    int updateByPrimaryKey(Menu record);

    List<Menu> selectMenusByUserId(String userId);

    List<Menu> selectByUserIdAndParentId(
            @Param("userId") String userId,
            @Param("menuId") String menuId);

    List<Menu> selectByRoleId(String roleId);

    List<Menu> selectByUserIdRoleId(@Param("roleId") String roleId, @Param("userId") String userId);

    List<Menu> selectBaseMenu();

    List<Menu> selectByParentId(String parentId);

    List<Menu> selectAllOrRoleId(@Param("roleId") String roleId, @Param("type") String type);

    List<Menu> selectAreaMenu(@Param("userId") String userId, @Param("type") String type);

    List<Menu> selectAllOrRoleIdByRegionId(@Param("roleId") String roleId,
            @Param("type") String type, @Param("regionId") String regionId);

    List<Menu> selectAreaMenuByRegionId(@Param("userId") String userId, @Param("type") String type,
            @Param("regionId") String regionId);

    List<Menu> selectMenuByRoleId(@Param("roleId") String roleId);

    List<Menu> selectMenusBySysId(@Param("userId") String userId, @Param("sysId") String sysId);

    List<Menu> selectButtonByMenuId(@Param("menuId") String menuId, @Param("userId") String userId);

    List<String> selectUserButton(@Param("parentId") String parentId,
            @Param("userId") String userId);

    List<Menu> selectSubMenu();

    List<Menu> selectMenuItemByUserId(@Param("userId") String userId,@Param("sysId") String sysId);

    List<Menu> selectAll();
}