package com.hywa.map.dao.mapper;

import com.hywa.map.dao.entity.ExamAttach;
import com.hywa.map.dao.entity.Notice;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
* t_web_notice  对应mapperInterface 接口类
* @create by 2019-02-18 14:53:53
* @author hywa
*/ 
@Mapper 
public interface NoticeMapper {
    /*
     * 新增
     */
    int add(Notice entity);

    /*
     * 修改
     */
    int update(Notice entity);

    /*
     * 逻辑删除
     */
    int put(@Param("id") String id, @Param("updateUser") String updateUser);
    /*
     * 物理删除
     */
    int delete(@Param("id") String id);
    /*
     * 根据名称统计记录数
     */
    int countByTitleName(@Param("titleName") String titleName,@Param("id") String id);
    /*
     * 批量修改状态
     */
    int updateStateBatch(@Param("state") int state,@Param("userId") String userId,@Param("list") List<Notice> idKeys);
    /*
     * 批量修改状态
     */
    int updateStateSingle(@Param("state") int state,@Param("userId") String userId,@Param("id") String id);
    /*
     * 根据id查询
     */
    Notice selectById(@Param("id") String id);
    /*
     * 根据标题、创建人、发布人、发布时间等查询
     */
    List<Notice> select(@Param("queryParam") String queryParam,@Param("beginDate") String beginDate,@Param("endDate") String endDate,@Param("noticeType") String noticeType,@Param("state") String state,@Param("dateFlag") String dateFlag);
    /*
     * 根据标题、创建人、发布人、发布时间等查询
     */
    List<Notice> selectBlack(@Param("queryParam") String queryParam,@Param("beginDate") String beginDate,@Param("endDate") String endDate,@Param("noticeType") String noticeType,@Param("state") String state,@Param("dateFlag") String dateFlag);
    /*
     * 新增附件信息
     */
    int insertAttach(ExamAttach entity);
    /*
     * 物理删除附件信息
     */
    int deleteAttachByNoticeId(@Param("noticeId") String noticeId);
    /*
     * 查询附件
     */
    List<ExamAttach> selectAttachByNoticeId(@Param("noticeId") String noticeId);
}

