package com.hywa.map.dao.mapper;
import com.hywa.map.dao.entity.OrchardInfo;
import com.hywa.map.representation.MapOrchardStatisRep;
import com.hywa.map.representation.OrchardRep;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
* t_orchard_info  对应mapperInterface 接口类
* @create by 2019-07-17 13:44:47
* @author hywa
*/ 
@Mapper 
public interface OrchardInfoMapper {
    /*
     * 新增
     */
    int add(OrchardInfo entity);
    /*
     * 根据园区编码统计记录数
     */
    int countByOrchardCode(@Param("orchardCode") String orchardCode, @Param("id") String id);
    /*
     * 根据园区名称统计记录数
     */
    int countByOrchardName(@Param("orchardName") String orchardName,@Param("id") String id);
    /*
     * 物理删除
     */
    int delete(@Param("id") String id);
    /*
     * 编辑
     */
    int update(OrchardInfo entity);
    /*
     * 逻辑删除
     */
    int put(@Param("id") String id);
    /*
     * 查询园区列表
     */
    List<OrchardRep> select(@Param("queryParam") String queryParam, @Param("induType") String induType, @Param("productName") String productName, @Param("id") String id);
    /*
     * 统计园区信息
     */
    MapOrchardStatisRep selectStatis();

}

