package com.hywa.map.dao.mapper;

import com.hywa.map.dao.entity.DictLabel;
import com.hywa.map.dao.entity.SysDict;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
* sys_dict  对应mapperInterface 接口类
* @create by 2018-12-13 13:41:59
* @author hywa
*/ 
@Mapper 
public interface SysDictMapper {
    /*
     * 新增
     */
    int add(SysDict sysDict);

    /*
     * 修改
     */
    int update(SysDict sysDict);

    /*
     * 逻辑删除
     */
    int put(@Param("id") String id, @Param("updateUser") String updateUser);
    /*
     * 物理删除
     */
    int delete(@Param("id") String id);
    /*
     * 根据字典名称统计记录数
     */
    int countByDictName(@Param("libId") String libId,@Param("dictName") String dictName, @Param("id") String id, @Param("parentId") String parentId);

    /*
     * 根据字典编码统计记录数
     */
    int countByDictCode(@Param("libId") String libId,@Param("dictCode") String dictCode, @Param("id") String id);

    /*
     * 根据字典名称、字典编码、字典标签查询
     */
    List<SysDict> select(@Param("queryParam") String queryParam, @Param("libId") String libId, @Param("id") String id);
    /*
     * 根据字典名称、字典编码、字典标签查询
     */
    List<SysDict> selectAll(@Param("libId") String libId, @Param("id") String id);
    /*
     * 根据id查询
     */
    SysDict selectById(@Param("id") String id);
    /*
     * 更新状态0-关闭 1-开通
     */
    int updateState(@Param("id") String id, @Param("updateUser") String updateUser,@Param("state") String state);
    /*
     * 根据字典id统计下级记录数
     */
    int countByDictId(@Param("dictId") String dictId);
    /*
     * 批量增加字典标签
     */
    void insertLabelBatch(List<DictLabel> dictLabel);
    /*
     * 根据字典id查询标签信息
     */
    List<DictLabel> selectDictLabel(@Param("dictId") String dictId);
    /*
     * 根据字典id删除标签信息
     */
    int deleteDictLabel(@Param("dictId") String dictId);
    /*
     * 批量增加字典
     */
    int insertDictBatch(List<SysDict> sysDict);

    /*
     * 根据库id查询
     */
    List<SysDict> selectByLibId(@Param("libId") String libId);
    /*
     * 根据库编码、字典编码查询
     */
    List<SysDict> selectByDictCode(@Param("libCode") String libCode,@Param("dictCode") String dictCode);
    /*
     * 根据库编码、字典编码、编码长度查询
     */
    List<SysDict> selectByDictCodeAndLen(@Param("libCode") String libCode,@Param("dictCode") String dictCode,@Param("codeLength") int codeLength,@Param("parentId") String parentId);
    /*
     * 根据库编码、字典编码查询，不包括本身
     */
    List<SysDict> selectByDictCodeNoSelf(@Param("libCode") String libCode,@Param("dictCode") String dictCode);

}

