package com.hywa.map.dao.mapper;

import com.hywa.map.dao.entity.TopicDb;
import com.hywa.map.dao.entity.TopicDbItem;
import com.hywa.map.dao.entity.TopicSource;
import com.hywa.map.representation.CommonView;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * t_topic_db  对应mapperInterface 接口类
 *
 * @author hywa
 * @create by 2019-05-13 15:13:54
 */
@Mapper
public interface TopicDbMapper {
    /*
     * 查询模板数据值信息
     */
    List<CommonView> select(@Param("topicId") String topicId);
    /*
     * 查询资源数据库信息
     */
    List<TopicDb> selectDb();
    /*
     * 查询资源数据库集信息
     */
    List<TopicDbItem> selectDbItem(@Param("dbId") String dbId);
    /*
     * 查询资源数据库字段信息
     */
    CommonView selectField(@Param("itemId") String itemId);
    /*
     * 查询数据库配置字段信息
     */
    TopicSource selectSource(@Param("topicId") String topicId);
}

