package com.hywa.map.dao.mapper;

import com.hywa.map.dao.entity.*;
import com.hywa.map.representation.MapTopicStatisRep;
import com.hywa.map.representation.TopicDetailRep;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * t_topic_info  对应mapperInterface 接口类
 *
 * @author hywa
 * @create by 2019-05-10 13:50:25
 */
@Mapper
public interface TopicInfoMapper {
    /*
     * 查询专题信息
     */
    List<TopicDetailRep> select(@Param("topicName") String topicName);
    /*
     * 根据id查询专题详细信息
     */
    TopicDetail selectDetailById(@Param("id") String id);
    /*
     * 根据id查询专题详细信息
     */
    TopicDetailRep selectById(@Param("id") String id);

    int add(TopicInfo entity);

    int update(TopicInfo entity);

    int insertIcon(@Param("list") List<TopicIcon> keys);

    int insertSource(TopicSource entity);

    int insertConfig(TopicConfig entity);
    /*
     * 根据专题名称统计记录数
     */
    int countByTopicName(@Param("topicName") String topicName, @Param("id") String id);
    /*
     * 物理删除专题图标信息
     */
    int deleteIconByTopicId(@Param("topicId") String topicId);
    /*
     * 物理删除专题数据库信息
     */
    int deleteSourceByTopicId(@Param("topicId") String topicId);
    /*
     * 物理删除专题配置信息
     */
    int deleteConfigByTopicId(@Param("topicId") String topicId);
    /*
     * 逻辑删除
     */
    int put(@Param("id") String id, @Param("updateUser") String updateUser);
    /*
     * 统计专题信息
     */
    List<MapTopicStatisRep> selectStatis();
}

