package com.hywa.map.dao.mapper;

import com.hywa.map.dao.entity.Combox;
import com.hywa.map.dao.entity.Recall;
import com.hywa.map.dao.entity.Use;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * t_mon_buy  对应mapperInterface 接口类
 *
 * @author hywa
 * @create by 2019-03-06 14:17:49
 */
@Mapper
public interface UseMapper {
    /*
     * 查询使用记录商品类别
     */
    List<Combox> selectGoodsType();

    /*
     * 查询使用记录
     */
    List<Use> select(@Param("queryParam") String queryParam, @Param("goodsType") String goodsType, @Param("beginDate") String beginDate, @Param("endDate") String endDate, @Param("farmerName") String farmerName);

    /*
     * 查询包装物回收商品类别
     */
    List<Combox> selectGoodsTypeRecall();

    /*
     * 查询包装物回收仓库类型
     */
    List<Combox> selectWarehouseRecall();

    /*
     * 查询包装物回收类型
     */
    List<Combox> selectTypeRecall();

    /*
     * 查询包装物回收记录
     */
    List<Recall> selectRecall(@Param("queryParam") String queryParam, @Param("goodsType") String goodsType, @Param("warehouse") String warehouse, @Param("beginDate") String beginDate, @Param("endDate") String endDate, @Param("recallType") String recallType, @Param("corpName") String corpName, @Param("dealer") String dealer, @Param("farmerName") String farmerName);

}

