package com.hywa.map.dao.mapper;

import com.hywa.map.dao.entity.User;
import com.hywa.map.dao.entity.UserExample;
import java.util.List;
import java.util.Map;

import com.hywa.map.dao.entity.UserIcon;
import com.hywa.map.representation.PersonRep;
import com.hywa.map.representation.SysRep;
import org.apache.ibatis.annotations.Param;

public interface UserMapper {
    int countByExample(UserExample example);

    int deleteByExample(UserExample example);

    int deleteByPrimaryKey(String id);

    int insert(User record);

    int insertSelective(User record);

    List<User> selectByExample(UserExample example);

    User selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") User record, @Param("example") UserExample example);

    int updateByExample(@Param("record") User record, @Param("example") UserExample example);

    int updateByPrimaryKeySelective(User record);

    int updateByPrimaryKey(User record);

    User selectByUserName(String userName);

    List<User> selectByRegionAndWorkUnit(@Param("name") String name,@Param("region") String region, @Param("workUnit")String workUnit);

    int deleteByUserId(String userId);

    Map<String,Object> selectByIdUserArea(@Param(value = "id") String id,@Param(value = "type") int type);

    Map<String,Object> selectByIdUserInfo(@Param(value = "id") String id);

    List<User> selectByRegionAndWorkUnitArea(@Param("name") String name,@Param("region") String region, @Param("workUnit")String workUnit, @Param("userId")String userId);

    int isBelongProvince(@Param("provinceId") String provinceId,@Param("cityId") String cityId);

    int isBelongCity(@Param("cityId") String cityId,@Param("countyId") String countyId);

    int matchAreaRole(@Param("roleId") String roleId,@Param("regionId") String regionId);

    List<SysRep> findSysInfoByUserId(@Param("userId")String userId, @Param("userName")String userName);

    int disableUserById(Map map);

    List<User> selectUserBySelf(@Param("name") String name, @Param("createUser")String createUser);

    int isReferencePurchasingPoint(@Param("id")String id);

    int isInformationSet();

    String finAreaNameById(@Param("id")String id);

    List<SysRep> findSysInfoAllByUserId(@Param("userId")String userId, @Param("userName")String userName);

    Map<String,Integer> examine(@Param("userName") String userName);

    int insertIcon(UserIcon record);

    int deleteIcon(@Param("userId") String userId);

    PersonRep selectUserInfo(@Param("id") String id);

    int updatePush(@Param("id") String id, @Param("isPush") String isPush);

    int updatePersonInfo(User record);
}