package com.hywa.map.dao.mapper;

import com.hywa.map.dao.entity.Weather;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;
import java.util.Map;

/**
* dap_weather  对应mapperInterface 接口类
* @create by 2018-08-06 15:02:49
* @author hywa
*/ 
@Mapper
public interface WeatherMapper {
    /**
     * 根据城市id获取天气信息
     * @param selectParam 城市代码
     * @return 当日天气温度和天气描述
     */
    List<Map<String,Object>> selectCurrWeather(Map<String, String> selectParam);
    /**
     * 根据城市id获取天气信息 单位：天
     * @param selectParam 城市代码
     * @return 天气温度和天气描述 单位：天
     */
    List<Map<String,Object>> selectDayWeather(Map<String, String> selectParam);
    /*新增*/
    int add(Weather model);
}

