package com.hywa.map.representation;

import com.hywa.map.dao.entity.Branch;

import java.io.Serializable;
import java.util.List;

public class BranchRep implements Serializable {

    private static final long serialVersionUID = -4963266899668807475L;
    /**
     * 主键
     */
    private String id;
    /**
     * 机构名称
     */
    private String branchName;
    /**
     * 上级id
     */
    private String parentId;
    /**
     * 上级名称
     */
    private String parentName;
    /**
     * 负责人
     */
    private String leader;
    /**
     * 电话
     */
    private String telNo;
    /**
     * 备注
     */
    private String remark;
    /*
     * 子节点
     */
    private List<BranchRep> children;
    public BranchRep(Branch branch) {
        this.setId(branch.getId());
        this.setBranchName(branch.getBranchName());
        this.setParentId(branch.getParentId());
        this.setParentName(branch.getParentName());
        this.setLeader(branch.getLeader());
        this.setTelNo(branch.getTelNo());
        this.setRemark(branch.getRemark());
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getBranchName() {
        return branchName;
    }

    public void setBranchName(String branchName) {
        this.branchName = branchName;
    }

    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    public String getParentName() {
        return parentName;
    }

    public void setParentName(String parentName) {
        this.parentName = parentName;
    }

    public String getLeader() {
        return leader;
    }

    public void setLeader(String leader) {
        this.leader = leader;
    }

    public String getTelNo() {
        return telNo;
    }

    public void setTelNo(String telNo) {
        this.telNo = telNo;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public List<BranchRep> getChildren() {
        return children;
    }

    public void setChildren(List<BranchRep> children) {
        this.children = children;
    }

    @Override
    public String toString() {
        return "BranchRep{" +
                "id='" + id + '\'' +
                ", branchName='" + branchName + '\'' +
                ", parentId='" + parentId + '\'' +
                ", parentName='" + parentName + '\'' +
                ", leader='" + leader + '\'' +
                ", telNo='" + telNo + '\'' +
                ", remark='" + remark + '\'' +
                ", children=" + children +
                '}';
    }
}


