package com.hywa.map.representation;

import com.hywa.map.common.utils.DateUtils;
import com.hywa.map.dao.entity.Log;

import java.io.Serializable;

public class LogRep implements Serializable {

    private static final long serialVersionUID = -4963266899668807475L;
    /*
     * 用户名
     */
    private String userName;
    /*
     * 操作菜单
     */
    private String menuName;
    /*
     * 请求ip
     */
    private String reqIp;
    /*
     * 操作结果
     */
    private String result;
    /*
     * 操作时间
     */
    private String createTime;
    /*
     * 失败原因
     */
    private String errorMessage;
    /*
     * 操作内容
     */
    private String content;

    public LogRep(Log log) {
        this.setUserName(log.getUserId());
        this.setMenuName(log.getMenuName());
        this.setReqIp(log.getReqIp());
        this.setResult(0 == log.getErrorCode() ? "成功" : "失败");
        this.setCreateTime(DateUtils.formatDate(log.getCreateTime(), "yyyy-MM-dd HH:mm:ss"));
        this.setErrorMessage(log.getErrorMessage());
        this.setContent(log.getContent());
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String getMenuName() {
        return menuName;
    }

    public void setMenuName(String menuName) {
        this.menuName = menuName;
    }

    public String getReqIp() {
        return reqIp;
    }

    public void setReqIp(String reqIp) {
        this.reqIp = reqIp;
    }

    public String getResult() {
        return result;
    }

    public void setResult(String result) {
        this.result = result;
    }

    public String getCreateTime() {
        return createTime;
    }

    public void setCreateTime(String createTime) {
        this.createTime = createTime;
    }

    public String getErrorMessage() {
        return errorMessage;
    }

    public void setErrorMessage(String errorMessage) {
        this.errorMessage = errorMessage;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    @Override
    public String toString() {
        return "LogRep{" +
                "userName='" + userName + '\'' +
                ", menuName='" + menuName + '\'' +
                ", reqIp='" + reqIp + '\'' +
                ", result='" + result + '\'' +
                ", createTime='" + createTime + '\'' +
                ", errorMessage='" + errorMessage + '\'' +
                ", content='" + content + '\'' +
                '}';
    }
}


