package com.hywa.map.representation;

import com.hywa.map.dao.entity.Menu;
import lombok.NoArgsConstructor;

import java.util.List;

@NoArgsConstructor
public class MenuItemRep {

    private String id;
    private List<String> auth;
    private String name;
    private String url;
    private int sort;
    private String icon;
    private String parentId;

    private List<MenuItemRep> childrenMenus;

    public MenuItemRep(Menu menu) {
        setId(menu.getId());
        setName(menu.getName());
        setUrl(menu.getDescription());
        setSort(menu.getSort());
        setIcon(menu.getIcon());
        setParentId(menu.getParentId());
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public List<String> getAuth() {
        return auth;
    }

    public void setAuth(List<String> auth) {
        this.auth = auth;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public int getSort() {
        return sort;
    }

    public void setSort(int sort) {
        this.sort = sort;
    }

    public String getIcon() {
        return icon;
    }

    public void setIcon(String icon) {
        this.icon = icon;
    }

    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    public List<MenuItemRep> getChildrenMenus() {
        return childrenMenus;
    }

    public void setChildrenMenus(List<MenuItemRep> childrenMenus) {
        this.childrenMenus = childrenMenus;
    }

    @Override
    public String toString() {
        return "MenuItemRep{" +
                "id='" + id + '\'' +
                ", auth=" + auth +
                ", name='" + name + '\'' +
                ", url='" + url + '\'' +
                ", sort=" + sort +
                ", icon='" + icon + '\'' +
                ", parentId='" + parentId + '\'' +
                ", childrenMenus=" + childrenMenus +
                '}';
    }
}
