package com.hywa.map.representation;

import com.hywa.map.dao.entity.Menu;

import java.util.ArrayList;
import java.util.List;

import lombok.NoArgsConstructor;

@NoArgsConstructor
public class MenuRep extends Menu {

    private String id;

    private String name;

    private String description;

    private String icon;

    private short status;

    private String parentId;

    private short type;

    private List<MenuRep> childMenus;

    private String createUser;

    private String roleId;
    private int isChecked;
    private String provinceId;//省id
    private String provinceName;//省名称
    private String cityId;//市id
    private String cityName;//市名称
    private String countyId;//县id
    private String countyName;//县名称
    private String regionId;//区域id
    @Override
    public String getCreateUser() {
        return createUser;
    }

    @Override
    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }

    public MenuRep(Menu menu) {
        setDescription(menu.getDescription());
        setIcon(menu.getIcon());
        setName(menu.getName());
        setParentId(menu.getParentId());
        setStatus((short)menu.getStatus());
        setType((short)menu.getType());
        setId(menu.getId());
        setRoleId(menu.getRoleId());
        setSort(menu.getSort());
        setIsChecked(menu.getIsChecked());
        setProvinceId(menu.getProvinceId());
        setCityId(menu.getCityId());
        setCountyId(menu.getCountyId());
        setRegionId(menu.getRegionId());
        if("#".equals(menu.getParentId())){
            setProvinceName(menu.getProvinceName());
            setCityName(menu.getCityName());
            setCountyName(menu.getCountyName());
        }
    }

    @Override
    public String getId() {
        return id;
    }

    @Override
    public void setId(String id) {
        this.id = id;
    }

    public List<MenuRep> getChildMenus() {
        return childMenus;
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public void setName(String name) {
        this.name = name;
    }

    @Override
    public String getDescription() {
        return description;
    }

    @Override
    public void setDescription(String description) {
        this.description = description;
    }

    @Override
    public Short getStatus() {
        return status;
    }

    public void setStatus(short status) {
        this.status = status;
    }

    @Override
    public String getParentId() {
        return parentId;
    }

    @Override
    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    @Override
    public Short getType() {
        return type;
    }

    public void setType(short type) {
        this.type = type;
    }

    @Override
    public String getIcon() {
        return icon;
    }

    @Override
    public void setIcon(String icon) {
        this.icon = icon;
    }

    public void setChildMenus(List<MenuRep> menuRepList) {
        if (menuRepList != null && menuRepList.size() != 0) {
            this.childMenus = new ArrayList<>(menuRepList);
        }
    }

    @Override
    public String getRoleId() {
        return roleId;
    }

    @Override
    public void setRoleId(String roleId) {
        this.roleId = roleId;
    }

    @Override
    public int getIsChecked() {
        return isChecked;
    }

    @Override
    public void setIsChecked(int isChecked) {
        this.isChecked = isChecked;
    }

    @Override
    public String getProvinceId() {
        return provinceId;
    }

    @Override
    public void setProvinceId(String provinceId) {
        this.provinceId = provinceId;
    }

    @Override
    public String getProvinceName() {
        return provinceName;
    }

    @Override
    public void setProvinceName(String provinceName) {
        this.provinceName = provinceName;
    }

    @Override
    public String getCityId() {
        return cityId;
    }

    @Override
    public void setCityId(String cityId) {
        this.cityId = cityId;
    }

    @Override
    public String getCityName() {
        return cityName;
    }

    @Override
    public void setCityName(String cityName) {
        this.cityName = cityName;
    }

    @Override
    public String getCountyId() {
        return countyId;
    }

    @Override
    public void setCountyId(String countyId) {
        this.countyId = countyId;
    }

    @Override
    public String getCountyName() {
        return countyName;
    }

    @Override
    public void setCountyName(String countyName) {
        this.countyName = countyName;
    }

    @Override
    public String getRegionId() {
        return regionId;
    }

    @Override
    public void setRegionId(String regionId) {
        this.regionId = regionId;
    }

    @Override
    public String toString() {
        return "MenuRep{" +
                "id='" + id + '\'' +
                ", name='" + name + '\'' +
                ", description='" + description + '\'' +
                ", icon='" + icon + '\'' +
                ", status=" + status +
                ", parentId='" + parentId + '\'' +
                ", type=" + type +
                ", childMenus=" + childMenus +
                ", createUser='" + createUser + '\'' +
                ", roleId='" + roleId + '\'' +
                ", isChecked=" + isChecked +
                ", provinceId='" + provinceId + '\'' +
                ", provinceName='" + provinceName + '\'' +
                ", cityId='" + cityId + '\'' +
                ", cityName='" + cityName + '\'' +
                ", countyId='" + countyId + '\'' +
                ", countyName='" + countyName + '\'' +
                ", regionId='" + regionId + '\'' +
                '}';
    }
}
