package com.hywa.map.representation;

import com.hywa.map.dao.entity.Menu;
import com.hywa.map.dao.entity.MenuNew;
import lombok.NoArgsConstructor;

import java.util.ArrayList;
import java.util.List;

@NoArgsConstructor
public class MenuRepNew extends MenuNew {

    private String id;

    private String name;

    private String description;

    private String icon;

    private short status;

    private String parentId;

    private short type;
    private boolean spread;
    private boolean disabled;
    private List<MenuRepNew> children;

    private String createUser;

    private String roleId;
    private int checked;
    private String provinceId;//省id
    private String provinceName;//省名称
    private String cityId;//市id
    private String cityName;//市名称
    private String countyId;//县id
    private String countyName;//县名称
    private String regionId;//区域id

    public String getCreateUser() {
        return createUser;
    }

    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }

    public MenuRepNew(Menu menu) {
        setDescription(menu.getDescription());
        setIcon(menu.getIcon());
        setName(menu.getName());
        setParentId(menu.getParentId());
        setStatus((short)menu.getStatus());
        setType((short)menu.getType());
        setId(menu.getId());
        setRoleId(menu.getRoleId());
        setSort(menu.getSort());
        setChecked(menu.getIsChecked());
        setProvinceId(menu.getProvinceId());
        setCityId(menu.getCityId());
        setCountyId(menu.getCountyId());
        setRegionId(menu.getRegionId());
        if("#".equals(menu.getParentId())){
            setProvinceName(menu.getProvinceName());
            setCityName(menu.getCityName());
            setCountyName(menu.getCountyName());
        }
        setSpread(true);
        setDisabled(false);
    }

    @Override
    public String getId() {
        return id;
    }

    @Override
    public void setId(String id) {
        this.id = id;
    }

    public List<MenuRepNew> getChildren() {
        return children;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Short getStatus() {
        return status;
    }

    public void setStatus(short status) {
        this.status = status;
    }

    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    public Short getType() {
        return type;
    }

    public void setType(short type) {
        this.type = type;
    }

    public String getIcon() {
        return icon;
    }

    public void setIcon(String icon) {
        this.icon = icon;
    }

    public void setChildren(List<MenuRepNew> menuRepList) {
        if (menuRepList != null && menuRepList.size() != 0) {
            this.children = new ArrayList<>(menuRepList);
        }
    }

    public String getRoleId() {
        return roleId;
    }

    public void setRoleId(String roleId) {
        this.roleId = roleId;
    }

    @Override
    public int getChecked() {
        return checked;
    }

    @Override
    public void setChecked(int checked) {
        this.checked = checked;
    }

    @Override
    public String getProvinceId() {
        return provinceId;
    }

    @Override
    public void setProvinceId(String provinceId) {
        this.provinceId = provinceId;
    }

    @Override
    public String getProvinceName() {
        return provinceName;
    }

    @Override
    public void setProvinceName(String provinceName) {
        this.provinceName = provinceName;
    }

    @Override
    public String getCityId() {
        return cityId;
    }

    @Override
    public void setCityId(String cityId) {
        this.cityId = cityId;
    }

    @Override
    public String getCityName() {
        return cityName;
    }

    @Override
    public void setCityName(String cityName) {
        this.cityName = cityName;
    }

    @Override
    public String getCountyId() {
        return countyId;
    }

    @Override
    public void setCountyId(String countyId) {
        this.countyId = countyId;
    }

    @Override
    public String getCountyName() {
        return countyName;
    }

    @Override
    public void setCountyName(String countyName) {
        this.countyName = countyName;
    }

    @Override
    public String getRegionId() {
        return regionId;
    }

    @Override
    public void setRegionId(String regionId) {
        this.regionId = regionId;
    }

    public boolean isSpread() {
        return spread;
    }

    public void setSpread(boolean spread) {
        this.spread = spread;
    }

    public boolean isDisabled() {
        return disabled;
    }

    public void setDisabled(boolean disabled) {
        this.disabled = disabled;
    }
}
