package com.hywa.map.representation;

import com.hywa.map.common.utils.DateUtils;
import com.hywa.map.dao.entity.Notice;

import java.io.Serializable;
import java.util.List;

public class NoticeRep implements Serializable {

    private static final long serialVersionUID = -4963266899668807475L;
    /**
     * 主键
     */
    private String id;
    /**
     * 标题
     */
    private String title;
    /**
     * 来源
     */
    private String origin;
    /**
     * 内容
     */
    private String content;
    /**
     * 类型 1-新闻 2-通知 3-公告 9-红黑榜
     */
    private short noticeType;
    /**
     * 类型 1-新闻 2-通知 3-公告 9-红黑榜
     */
    private String noticeTypeName;
    /**
     * 子类型
     */
    private String subType;
    /**
     * 子类型名称
     */
    private String subTypeName;
    /**
     * 状态 0-未发布 1-已发布 2-撤回
     */
    private short state;
    /**
     * 发布时间
     */
    private String publishTime;
    /**
     * 发布人
     */
    private String publishUser;
    /**
     * 批次
     */
    private String batchNo;
    /**
     * 创建人
     */
    private String createUser;
    /**
     * 创建时间
     */
    private String createDate;
    /**
     * 附件
     */
    private List<FileReq> files;

    public NoticeRep(Notice entity) {
        this.setId(entity.getId());
        this.setTitle(entity.getTitle());
        this.setContent(entity.getContent());
        short noticeType = entity.getNoticeType();
        this.setNoticeType(noticeType);
        this.setSubType(entity.getSubType());
        this.setState(entity.getState());
        this.setPublishTime(DateUtils.formatDate(entity.getPublishTime(), "yyyy-MM-dd HH:mm:ss"));
        this.setPublishUser(entity.getPublishUser());
        this.setBatchNo(entity.getBatchNo());
        this.setCreateDate(DateUtils.formatDate(entity.getCreateDate(), "yyyy-MM-dd HH:mm:ss"));
        this.setCreateUser(entity.getCreateUser());
        this.setOrigin(entity.getOrigin());
        this.setSubTypeName(entity.getSubTypeName());
        String noticeTypeName = null;
        if (noticeType == 1) {
            noticeTypeName = "新闻";
        } else if (noticeType == 2) {
            noticeTypeName = "通知公告";
        }
        this.setNoticeTypeName(noticeTypeName);
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public short getNoticeType() {
        return noticeType;
    }

    public void setNoticeType(short noticeType) {
        this.noticeType = noticeType;
    }

    public String getSubType() {
        return subType;
    }

    public void setSubType(String subType) {
        this.subType = subType;
    }

    public short getState() {
        return state;
    }

    public void setState(short state) {
        this.state = state;
    }

    public String getPublishTime() {
        return publishTime;
    }

    public void setPublishTime(String publishTime) {
        this.publishTime = publishTime;
    }

    public String getPublishUser() {
        return publishUser;
    }

    public void setPublishUser(String publishUser) {
        this.publishUser = publishUser;
    }

    public String getBatchNo() {
        return batchNo;
    }

    public void setBatchNo(String batchNo) {
        this.batchNo = batchNo;
    }

    public String getCreateUser() {
        return createUser;
    }

    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }

    public String getCreateDate() {
        return createDate;
    }

    public void setCreateDate(String createDate) {
        this.createDate = createDate;
    }

    public String getOrigin() {
        return origin;
    }

    public void setOrigin(String origin) {
        this.origin = origin;
    }

    public String getSubTypeName() {
        return subTypeName;
    }

    public void setSubTypeName(String subTypeName) {
        this.subTypeName = subTypeName;
    }

    public String getNoticeTypeName() {
        return noticeTypeName;
    }

    public void setNoticeTypeName(String noticeTypeName) {
        this.noticeTypeName = noticeTypeName;
    }

    public List<FileReq> getFiles() {
        return files;
    }

    public void setFiles(List<FileReq> files) {
        this.files = files;
    }

    @Override
    public String toString() {
        return "NoticeRep{" +
                "id='" + id + '\'' +
                ", title='" + title + '\'' +
                ", origin='" + origin + '\'' +
                ", content='" + content + '\'' +
                ", noticeType=" + noticeType +
                ", noticeTypeName='" + noticeTypeName + '\'' +
                ", subType='" + subType + '\'' +
                ", subTypeName='" + subTypeName + '\'' +
                ", state=" + state +
                ", publishTime='" + publishTime + '\'' +
                ", publishUser='" + publishUser + '\'' +
                ", batchNo='" + batchNo + '\'' +
                ", createUser='" + createUser + '\'' +
                ", createDate='" + createDate + '\'' +
                ", files=" + files +
                '}';
    }
}


