package com.hywa.map.representation;

import com.hywa.map.dao.entity.OrchardProduct;

import java.io.Serializable;
import java.util.List;

public class OrchardReq implements Serializable {
    private static final long serialVersionUID = 1L;
    /**
     * 主键
     */
    private String id;
    /**
     * 园区编码
     */
    private String orchardCode;
    /**
     * 园区名称
     */
    private String orchardName;
    /**
     * 园区面积(平方米)
     */
    private String orchardArea;
    /**
     * 行业类型 01-农业 02-林业 03-畜牧业 04-渔业 05-农林牧渔服务业
     */
    private String induType;
    /**
     * 人员数
     */
    private String workerCount;
    /**
     * 建园开始日期
     */
    private String beginDate;
    /**
     * 建园结束日期
     */
    private String endDate;
    /**
     * 负责人
     */
    private String leaderName;
    /**
     * 联系电话
     */
    private String telNo;
    /**
     * 海拔
     */
    private String elevation;
    /**
     * 园区简介
     */
    private String orchardDesc;
    //产出物信息
    private List<OrchardProduct> products;
    /**
     * 地址
     */
    private String address;
    /**
     * 省id
     */
    private String provinceId;
    /**
     * 市id
     */
    private String cityId;
    /**
     * 县id
     */
    private String countyId;
    /**
     * 镇id
     */
    private String townId;
    /**
     * 村id
     */
    private String villageId;
    /**
     * 经度
     */
    private String longitude;
    /**
     * 纬度
     */
    private String latitude;
    /**
     * 园区边界
     */
    private String orchardBorder;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getOrchardCode() {
        return orchardCode;
    }

    public void setOrchardCode(String orchardCode) {
        this.orchardCode = orchardCode;
    }

    public String getOrchardName() {
        return orchardName;
    }

    public void setOrchardName(String orchardName) {
        this.orchardName = orchardName;
    }

    public String getOrchardArea() {
        return orchardArea;
    }

    public void setOrchardArea(String orchardArea) {
        this.orchardArea = orchardArea;
    }

    public String getInduType() {
        return induType;
    }

    public void setInduType(String induType) {
        this.induType = induType;
    }

    public String getWorkerCount() {
        return workerCount;
    }

    public void setWorkerCount(String workerCount) {
        this.workerCount = workerCount;
    }

    public String getBeginDate() {
        return beginDate;
    }

    public void setBeginDate(String beginDate) {
        this.beginDate = beginDate;
    }

    public String getEndDate() {
        return endDate;
    }

    public void setEndDate(String endDate) {
        this.endDate = endDate;
    }

    public String getLeaderName() {
        return leaderName;
    }

    public void setLeaderName(String leaderName) {
        this.leaderName = leaderName;
    }

    public String getTelNo() {
        return telNo;
    }

    public void setTelNo(String telNo) {
        this.telNo = telNo;
    }

    public String getElevation() {
        return elevation;
    }

    public void setElevation(String elevation) {
        this.elevation = elevation;
    }

    public String getOrchardDesc() {
        return orchardDesc;
    }

    public void setOrchardDesc(String orchardDesc) {
        this.orchardDesc = orchardDesc;
    }

    public List<OrchardProduct> getProducts() {
        return products;
    }

    public void setProducts(List<OrchardProduct> products) {
        this.products = products;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getProvinceId() {
        return provinceId;
    }

    public void setProvinceId(String provinceId) {
        this.provinceId = provinceId;
    }

    public String getCityId() {
        return cityId;
    }

    public void setCityId(String cityId) {
        this.cityId = cityId;
    }

    public String getCountyId() {
        return countyId;
    }

    public void setCountyId(String countyId) {
        this.countyId = countyId;
    }

    public String getTownId() {
        return townId;
    }

    public void setTownId(String townId) {
        this.townId = townId;
    }

    public String getVillageId() {
        return villageId;
    }

    public void setVillageId(String villageId) {
        this.villageId = villageId;
    }

    public String getLongitude() {
        return longitude;
    }

    public void setLongitude(String longitude) {
        this.longitude = longitude;
    }

    public String getLatitude() {
        return latitude;
    }

    public void setLatitude(String latitude) {
        this.latitude = latitude;
    }

    public String getOrchardBorder() {
        return orchardBorder;
    }

    public void setOrchardBorder(String orchardBorder) {
        this.orchardBorder = orchardBorder;
    }

    @Override
    public String toString() {
        return "OrchardReq{" +
                "id='" + id + '\'' +
                ", orchardCode='" + orchardCode + '\'' +
                ", orchardName='" + orchardName + '\'' +
                ", orchardArea='" + orchardArea + '\'' +
                ", induType='" + induType + '\'' +
                ", workerCount='" + workerCount + '\'' +
                ", beginDate='" + beginDate + '\'' +
                ", endDate='" + endDate + '\'' +
                ", leaderName='" + leaderName + '\'' +
                ", telNo='" + telNo + '\'' +
                ", elevation='" + elevation + '\'' +
                ", orchardDesc='" + orchardDesc + '\'' +
                ", products=" + products +
                ", address='" + address + '\'' +
                ", provinceId='" + provinceId + '\'' +
                ", cityId='" + cityId + '\'' +
                ", countyId='" + countyId + '\'' +
                ", townId='" + townId + '\'' +
                ", villageId='" + villageId + '\'' +
                ", longitude='" + longitude + '\'' +
                ", latitude='" + latitude + '\'' +
                ", orchardBorder='" + orchardBorder + '\'' +
                '}';
    }
}
