package com.hywa.map.representation;

import java.io.Serializable;

import lombok.ToString;

import static com.hywa.map.common.enums.CommonEnum.FAILURE;
import static com.hywa.map.common.enums.CommonEnum.SUCCESS;

@ToString
public class ResponseBase<T> implements Serializable {

    private static final long serialVersionUID = -4963266899668807475L;
    private ResponseHead retHead;
    private T retBody;
    //private ButtonRep buttonRep;

    public ResponseHead getRetHead() {
        return retHead;
    }

    public void setRetHead(ResponseHead retHead) {
        this.retHead = retHead;
    }

    public void setRetHead(Short code, String msg) {
        this.retHead = new ResponseHead(code, msg);
    }

    public T getRetBody() {
        return retBody;
    }

    public void setRetBody(T retBody) {
        this.retBody = retBody;
    }

    public ResponseBase<T> success() {
        this.setRetHead(SUCCESS.getIndex(), SUCCESS.getValue());

        return this;
    }

    public ResponseBase<T> failure() {
        this.setRetHead(FAILURE.getIndex(), FAILURE.getValue());
        return this;
    }

    public ResponseBase<T> failure(short errCode, String errMsg) {
        this.setRetHead(errCode, errMsg);
        return this;
    }

    public static long getSerialVersionUID() {
        return serialVersionUID;
    }

}

