package com.hywa.map.representation;

import com.hywa.map.dao.entity.Role;

import java.util.List;
import javax.validation.constraints.NotNull;
import lombok.NoArgsConstructor;

@NoArgsConstructor
public class RoleRep {

    private String id;

    @NotNull(message = "角色名字不能为空")
    private String name;
    @NotNull(message = "角色描述不能为空")
    private String description;
    private String code;
    private List<Object> menuReps;
    private String createUser;
    private String updateUser;
    private String regionId;
    private String provinceId;
    private String cityId;
    private String countyId;
    private String provinceName;
    private String cityName;
    private String countyName;
    /** 状态 0-正常 1-锁定 2-禁用*/
    private Integer status;

    public RoleRep(Role role) {
        this.setId(role.getId());
        this.setName(role.getName());
        this.setDescription(role.getDescription());
        this.setCode(role.getCode());
        this.setRegionId(role.getRegionId());
        this.setProvinceId(role.getProvinceId());
        this.setCityId(role.getCityId());
        this.setCountyId(role.getCountyId());
        this.setStatus(role.getStatus());
        this.setProvinceName(role.getProvinceName());
        this.setCityName(role.getCityName());
        this.setCountyName(role.getCountyName());
    }

    private void setCode(String code) {
        this.code = code;
    }

    private void setDescription(String description) {
        this.description = description;
    }

    private void setName(String name) {
        this.name = name;
    }

    private void setId(String id) {
        this.id = id;
    }

    public String getId() {
        return id;
    }

    public String getName() {
        return name;
    }

    public String getDescription() {
        return description;
    }

    public String getCode() {
        return code;
    }

	public List<Object> getMenuReps() {
		return menuReps;
	}

	public void setMenuReps(List<Object> menuReps) {
		this.menuReps = menuReps;
	}

    public String getCreateUser() {
        return createUser;
    }

    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }

    public String getUpdateUser() {
        return updateUser;
    }

    public void setUpdateUser(String updateUser) {
        this.updateUser = updateUser;
    }

    public String getRegionId() {
        return regionId;
    }

    public void setRegionId(String regionId) {
        this.regionId = regionId;
    }

    public String getProvinceId() {
        return provinceId;
    }

    public void setProvinceId(String provinceId) {
        this.provinceId = provinceId;
    }

    public String getCityId() {
        return cityId;
    }

    public void setCityId(String cityId) {
        this.cityId = cityId;
    }

    public String getCountyId() {
        return countyId;
    }

    public void setCountyId(String countyId) {
        this.countyId = countyId;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public String getProvinceName() {
        return provinceName;
    }

    public void setProvinceName(String provinceName) {
        this.provinceName = provinceName;
    }

    public String getCityName() {
        return cityName;
    }

    public void setCityName(String cityName) {
        this.cityName = cityName;
    }

    public String getCountyName() {
        return countyName;
    }

    public void setCountyName(String countyName) {
        this.countyName = countyName;
    }
}
