package com.hywa.map.representation;

import com.hywa.map.dao.entity.SysArea;

import java.io.Serializable;

/**
 * t_sys_area 实体类 对应表名
 *
 * @author hywa
 * @create by 2019-05-07 15:32:48
 */
public class SysAreaRep implements Serializable {

    private static final long serialVersionUID = 1L;
    /**
     * 主键
     */
    private int id;
    /**
     * 行政区域ID
     */
    private String posId;
    /**
     * 父级行政区域ID
     */
    private String parentId;
    /**
     * 行政类型：1（省）、2（城市）、3（区县市）、4（乡镇）、5（村）
     */
    private int posType;
    /**
     * 名称
     */
    private String posName;
    /**
     * 地理经度
     */
    private String posLon;
    /**
     * 地理纬度
     */
    private String posLat;
    /**
     * 图标经度
     */
    private String iconLon;
    /**
     * 图标纬度
     */
    private String iconLat;

    public SysAreaRep(SysArea entity) {
        this.setId(entity.getId());
        this.setPosId(entity.getPosId());
        this.setParentId(entity.getParentId());
        this.setPosType(entity.getPosType());
        this.setPosName(entity.getPosName());
        this.setPosLon(entity.getPosLon());
        this.setPosLat(entity.getPosLat());
        this.setIconLon(entity.getIconLon());
        this.setIconLat(entity.getIconLat());
    }

    public SysAreaRep() {

    }

    public void setId(int id) {
        this.id = id;
    }

    public int getId() {
        return id;
    }

    public void setPosId(String posId) {
        this.posId = posId;
    }

    public String getPosId() {
        return posId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    public String getParentId() {
        return parentId;
    }

    public void setPosType(int posType) {
        this.posType = posType;
    }

    public int getPosType() {
        return posType;
    }

    public void setPosName(String posName) {
        this.posName = posName;
    }

    public String getPosName() {
        return posName;
    }

    public void setPosLon(String posLon) {
        this.posLon = posLon;
    }

    public String getPosLon() {
        return posLon;
    }

    public void setPosLat(String posLat) {
        this.posLat = posLat;
    }

    public String getPosLat() {
        return posLat;
    }

    public void setIconLon(String iconLon) {
        this.iconLon = iconLon;
    }

    public String getIconLon() {
        return iconLon;
    }

    public void setIconLat(String iconLat) {
        this.iconLat = iconLat;
    }

    public String getIconLat() {
        return iconLat;
    }

    @Override
    public String toString() {
        return "SysAreaRep{" +
                "id=" + id +
                ", posId='" + posId + '\'' +
                ", parentId='" + parentId + '\'' +
                ", posType=" + posType +
                ", posName='" + posName + '\'' +
                ", posLon='" + posLon + '\'' +
                ", posLat='" + posLat + '\'' +
                ", iconLon='" + iconLon + '\'' +
                ", iconLat='" + iconLat + '\'' +
                '}';
    }
}

