package com.hywa.map.representation;

import com.hywa.map.dao.entity.SysDict;

import java.io.Serializable;
import java.util.List;

public class SysDictRep implements Serializable {

    private static final long serialVersionUID = -4963266899668807475L;
    /**
     * 主键
     */
    private String id;
    /**
     * 库id
     */
    private String libId;
    /**
     * 上级id
     */
    private String parentId;
    /**
     * 上级名称
     */
    private String parentName;
    /**
     * 字典名称
     */
    private String dictName;
    /**
     * 字典编码
     */
    private String dictCode;
    /**
     * 备注
     */
    private String remark;
    /**
     * 状态0-关闭 1-开通
     */
    private int state;
    /**
     * 完整字典编码
     */
    private String allDictCode;
    /**
     * 字典标签
     */
    List<String> labels;
    /*
     * 子节点
     */
    private List<SysDictRep> children;
    /**
     * 是否存在子节点
     */
    private boolean isParent;

    public SysDictRep(SysDict sysDict) {
        this.setId(sysDict.getId());
        this.setLibId(sysDict.getLibId());
        this.setParentId(sysDict.getParentId());
        this.setDictName(sysDict.getDictName());
        this.setDictCode(sysDict.getDictCode());
        this.setRemark(sysDict.getRemark());
        this.setState(sysDict.getState());
        this.setAllDictCode(sysDict.getAllDictCode());
        this.setIsParent(sysDict.getHasChildren() == 1 ? true : false);
        this.setParentName(sysDict.getParentName());
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getLibId() {
        return libId;
    }

    public void setLibId(String libId) {
        this.libId = libId;
    }

    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    public String getDictName() {
        return dictName;
    }

    public void setDictName(String dictName) {
        this.dictName = dictName;
    }

    public String getDictCode() {
        return dictCode;
    }

    public void setDictCode(String dictCode) {
        this.dictCode = dictCode;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public int getState() {
        return state;
    }

    public void setState(int state) {
        this.state = state;
    }

    public List<String> getLabels() {
        return labels;
    }

    public void setLabels(List<String> labels) {
        this.labels = labels;
    }

    public List<SysDictRep> getChildren() {
        return children;
    }

    public void setChildren(List<SysDictRep> children) {
        this.children = children;
    }

    public String getAllDictCode() {
        return allDictCode;
    }

    public void setAllDictCode(String allDictCode) {
        this.allDictCode = allDictCode;
    }

    public boolean getIsParent() {
        return isParent;
    }

    public void setIsParent(boolean parent) {
        isParent = parent;
    }

    public String getParentName() {
        return parentName;
    }

    public void setParentName(String parentName) {
        this.parentName = parentName;
    }

    @Override
    public String toString() {
        return "SysDictRep{" +
                "id='" + id + '\'' +
                ", libId='" + libId + '\'' +
                ", parentId='" + parentId + '\'' +
                ", parentName='" + parentName + '\'' +
                ", dictName='" + dictName + '\'' +
                ", dictCode='" + dictCode + '\'' +
                ", remark='" + remark + '\'' +
                ", state=" + state +
                ", allDictCode='" + allDictCode + '\'' +
                ", labels=" + labels +
                ", children=" + children +
                ", isParent=" + isParent +
                '}';
    }
}


