package com.hywa.map.representation;

import com.hywa.map.common.utils.DateUtils;
import com.hywa.map.dao.entity.Use;

import java.io.Serializable;

public class UseRep implements Serializable {
    private static final long serialVersionUID = 1L;
    /**
     * 主键
     */
    private String id;
    /**
     * 经销商id
     */
    private String dealerId;
    /**
     * 经销商
     */
    private String dealer;
    /**
     * 农企农户
     */
    private String farmerName;
    /**
     * 农事编号
     */
    private String farmId;
    /**
     * 使用日期
     */
    private String useDate;
    /**
     * 商品类别
     */
    private String goodsType;
    /**
     * 商品编号
     */
    private String goodsId;
    /**
     * 商品名称
     */
    private String goodsName;
    /**
     * 通用名
     */
    private String commName;
    /**
     * 规格型号
     */
    private String model;
    /**
     * 单位
     */
    private String unit;
    /**
     * 仓库
     */
    private String warehouse;
    /**
     * 数量
     */
    private String total;
    /**
     * 登记证号
     */
    private String regNo;
    /**
     * 生产许可证号
     */
    private String certId;
    /**
     * 生产厂家
     */
    private String corpName;
    /**
     * 批号
     */
    private String batchNo;
    /**
     * 生产日期
     */
    private String geneDate;
    /**
     * 有效期（天）
     */
    private String period;

    public UseRep(Use entity) {
        this.setId(entity.getId());
        this.setDealerId(entity.getDealerId());
        this.setDealer(entity.getDealer());
        this.setFarmerName(entity.getFarmerName());
        this.setFarmId(entity.getFarmId());
        this.setUseDate(DateUtils.formatDate(entity.getUseDate(), "yyyy-MM-dd"));
        this.setGoodsId(entity.getGoodsId());
        this.setGoodsName(entity.getGoodsName());
        this.setCommName(entity.getCommName());
        this.setGoodsType(entity.getGoodsType());
        this.setUnit(entity.getUnit());
        this.setModel(entity.getModel());
        this.setBatchNo(entity.getBatchNo());
        this.setGeneDate(DateUtils.formatDate(entity.getGeneDate(), "yyyy-MM-dd"));
        this.setPeriod(entity.getPeriod());
        this.setTotal(entity.getTotal());
        this.setWarehouse(entity.getWarehouse());
        this.setRegNo(entity.getRegNo());
        this.setCertId(entity.getCertId());
        this.setCorpName(entity.getCorpName());
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getDealerId() {
        return dealerId;
    }

    public void setDealerId(String dealerId) {
        this.dealerId = dealerId;
    }

    public String getDealer() {
        return dealer;
    }

    public void setDealer(String dealer) {
        this.dealer = dealer;
    }

    public String getFarmerName() {
        return farmerName;
    }

    public void setFarmerName(String farmerName) {
        this.farmerName = farmerName;
    }

    public String getFarmId() {
        return farmId;
    }

    public void setFarmId(String farmId) {
        this.farmId = farmId;
    }

    public String getUseDate() {
        return useDate;
    }

    public void setUseDate(String useDate) {
        this.useDate = useDate;
    }

    public String getGoodsType() {
        return goodsType;
    }

    public void setGoodsType(String goodsType) {
        this.goodsType = goodsType;
    }

    public String getGoodsId() {
        return goodsId;
    }

    public void setGoodsId(String goodsId) {
        this.goodsId = goodsId;
    }

    public String getGoodsName() {
        return goodsName;
    }

    public void setGoodsName(String goodsName) {
        this.goodsName = goodsName;
    }

    public String getCommName() {
        return commName;
    }

    public void setCommName(String commName) {
        this.commName = commName;
    }

    public String getModel() {
        return model;
    }

    public void setModel(String model) {
        this.model = model;
    }

    public String getUnit() {
        return unit;
    }

    public void setUnit(String unit) {
        this.unit = unit;
    }

    public String getWarehouse() {
        return warehouse;
    }

    public void setWarehouse(String warehouse) {
        this.warehouse = warehouse;
    }

    public String getTotal() {
        return total;
    }

    public void setTotal(String total) {
        this.total = total;
    }

    public String getRegNo() {
        return regNo;
    }

    public void setRegNo(String regNo) {
        this.regNo = regNo;
    }

    public String getCertId() {
        return certId;
    }

    public void setCertId(String certId) {
        this.certId = certId;
    }

    public String getCorpName() {
        return corpName;
    }

    public void setCorpName(String corpName) {
        this.corpName = corpName;
    }

    public String getBatchNo() {
        return batchNo;
    }

    public void setBatchNo(String batchNo) {
        this.batchNo = batchNo;
    }

    public String getGeneDate() {
        return geneDate;
    }

    public void setGeneDate(String geneDate) {
        this.geneDate = geneDate;
    }

    public String getPeriod() {
        return period;
    }

    public void setPeriod(String period) {
        this.period = period;
    }

    @Override
    public String toString() {
        return "UseRep{" +
                "id='" + id + '\'' +
                ", dealerId='" + dealerId + '\'' +
                ", dealer='" + dealer + '\'' +
                ", farmerName='" + farmerName + '\'' +
                ", farmId='" + farmId + '\'' +
                ", useDate='" + useDate + '\'' +
                ", goodsType='" + goodsType + '\'' +
                ", goodsId='" + goodsId + '\'' +
                ", goodsName='" + goodsName + '\'' +
                ", commName='" + commName + '\'' +
                ", model='" + model + '\'' +
                ", unit='" + unit + '\'' +
                ", warehouse='" + warehouse + '\'' +
                ", total='" + total + '\'' +
                ", regNo='" + regNo + '\'' +
                ", certId='" + certId + '\'' +
                ", corpName='" + corpName + '\'' +
                ", batchNo='" + batchNo + '\'' +
                ", geneDate='" + geneDate + '\'' +
                ", period='" + period + '\'' +
                '}';
    }
}
