package com.hywa.map.service.common;

import com.hywa.map.representation.TempHour;
import com.hywa.map.representation.WeatherForecast;

/**
* dap_weather  对应ServiceInterface 接口类
* @create by 2018-08-06 15:02:49
* @author hywa
*/ 
public interface WeatherService {
    /**
     * 根据城市id获取天气信息
     * @param cityCode 城市代码 需要使用高德的区域代码
     * @return 天气实体类包括当日天气和预报天气，其中预报天气支持3天
     */
    WeatherForecast getWeather(String cityCode);
    /**
     * 获取城市最近24小时天气温度
     * @param cityCode 城市id
     * @return 天气温度信息
     */
    TempHour getHourWeather(String cityCode);
}

