package com.hywa.map.service.log.impl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.hywa.map.common.utils.StringUtils;
import com.hywa.map.dao.entity.*;
import com.hywa.map.dao.mapper.LogMapper;
import com.hywa.map.representation.*;
import com.hywa.map.service.log.LogService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Slf4j
@Service
public class LogServiceImpl implements LogService {

    @Autowired
    private LogMapper logMapper;

    @Override
    public LogReps queryAll(int pageNo, int pageSize, String menuName, String userName, String beginDate, String endDate) {
        PageHelper.startPage(pageNo, pageSize, true);
        beginDate = StringUtils.isEmpty(beginDate) ? "1900-01-01 00:00:00" : beginDate + " 00:00:00";
        endDate = StringUtils.isEmpty(endDate) ? "9999-12-12 23:59:59" : endDate + " 23:59:59";
        List<Log> logs = null;
        logs = logMapper.detailInfo(menuName, userName, beginDate, endDate);
        PageInfo<Log> page = new PageInfo<>(logs);
        List<LogRep> logRepList = new ArrayList<>();
        for (Log log : logs) {
            LogRep logRep = new LogRep(log);
            logRepList.add(logRep);
        }
        return new LogReps(page.getTotal(), logRepList);
    }
}
