package com.hywa.map.service.login;

import com.hywa.map.dao.entity.User;
import com.hywa.map.representation.*;
import com.hywa.map.representation.ext.UserRepExt;
import java.lang.reflect.InvocationTargetException;
import java.util.List;
import java.util.Map;


public interface UserService {

    User findByName(String username);

    void save(UserRepExt userRep);

    UserReps findUsers(int pageNo, int pageSize, String name, String region, String workUnit,String userName,String userId);

    UserRep userLogin(String userName, String psw);

    boolean delete(String userId);

    void updateUserRole(String userId, List<String> roleReps);

    UserRep findById(String userId);

    boolean phoneIsEmpty(String phone);

    Map<String, Object> findAllById(String id)
            throws IllegalAccessException, NoSuchMethodException, InvocationTargetException;

    void update(UserRepExt userRep, String userId);

	boolean nameIsEmpty(String username, String id);
	
	void changePwd(NewUserInfoRep newUserInfoRep);

    void setAuthority(String userId);

    boolean checkArea(String userId,String regionId);

    boolean checkAreaRole(String roleId,String regionId);

    List<SysRep> findSysInfoByUserId(String userId, String userName);

    List<SysRep> findSysInfoAllByUserId(String userId, String userName);

    void disableUser(Map map);

    boolean isInformationSet();
    void insertIcon(String userId,String icon);

    void updatePush(SetReq setReq);

    void updatePersonInfo(UserRepExt userRep, String userId);

    void resetPwd(NewUserInfoRep newUserInfoRep);
}
