package com.hywa.map.service.use.impl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.hywa.map.common.utils.DateUtils;
import com.hywa.map.common.utils.ExcelUtils;
import com.hywa.map.common.utils.StringUtils;
import com.hywa.map.config.EnvProperties;
import com.hywa.map.dao.entity.*;
import com.hywa.map.dao.mapper.UseMapper;
import com.hywa.map.representation.*;
import com.hywa.map.service.use.UseService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.File;
import java.util.ArrayList;
import java.util.Date;
import java.util.LinkedHashMap;
import java.util.List;

/**
 * t_mon_buy  对应ServiceImpl 实现类
 *
 * @author hywa
 * @create by 2019-03-06 14:17:50
 */
@Slf4j
@Service
public class UseServiceImpl implements UseService {

    @Autowired
    private UseMapper useMapper;
    @Autowired
    EnvProperties envProperties;


    @Override
    public ComboxReps selectGoodsType() {
        List<Combox> list = useMapper.selectGoodsType();
        if (list == null) {
            return null;
        }
        List<ComboxRep> repList = new ArrayList<>();
        for (int i = 0; i < list.size(); i++) {
            ComboxRep repObj = new ComboxRep(list.get(i));
            repObj.setId((i + 1) + "");
            repList.add(repObj);
        }
        return new ComboxReps((long) repList.size(), repList);
    }

    @Override
    public UseReps selectAll(int pageNo, int pageSize, String queryParam, String year, String month, String goodsType,String farmerName) {
        PageHelper.startPage(pageNo, pageSize, true);
        String beginDate = "";
        String endDate = "";
        if (StringUtils.isEmpty(year) && StringUtils.isEmpty(month)) {
            beginDate = "1900-01-01 00:00:00";
            endDate = "9999-12-31 23:59:59";
        }
        if (StringUtils.isEmpty(year) && StringUtils.isNotEmpty(month)) {
            return null;
        }
        if (StringUtils.isNotEmpty(year) && StringUtils.isEmpty(month)) {
            beginDate = year + "-01-01 00:00:00";
            endDate = year + "-12-31 23:59:59";
        }
        if (StringUtils.isNotEmpty(year) && StringUtils.isNotEmpty(month)) {
            beginDate = year + "-" + month + "-01 00:00:00";
            endDate = year + "-" + month + "-31 23:59:59";
        }
        List<Use> list = useMapper.select(queryParam, goodsType, beginDate, endDate,farmerName);
        List<UseRep> repList = new ArrayList<>();
        for (Use item : list) {
            UseRep repObj = new UseRep(item);
            repList.add(repObj);
        }
        log.info("查询使用记录完成，请求数据：queryParam|" + queryParam + "，goodsType|" + goodsType + "，year|" + year + "，month|" + month);
        return new UseReps(new PageInfo<>(list).getTotal(), repList);
    }

    @Override
    public ComboxReps selectGoodsTypeRecall() {
        List<Combox> list = useMapper.selectGoodsTypeRecall();
        if (list == null) {
            return null;
        }
        List<ComboxRep> repList = new ArrayList<>();
        for (int i = 0; i < list.size(); i++) {
            ComboxRep repObj = new ComboxRep(list.get(i));
            repObj.setId((i + 1) + "");
            repList.add(repObj);
        }
        return new ComboxReps((long) repList.size(), repList);
    }

    @Override
    public ComboxReps selectWarehouseRecall() {
        List<Combox> list = useMapper.selectWarehouseRecall();
        if (list == null) {
            return null;
        }
        List<ComboxRep> repList = new ArrayList<>();
        for (int i = 0; i < list.size(); i++) {
            ComboxRep repObj = new ComboxRep(list.get(i));
            repObj.setId((i + 1) + "");
            repList.add(repObj);
        }
        return new ComboxReps((long) repList.size(), repList);
    }

    @Override
    public ComboxReps selectTypeRecall() {
        List<Combox> list = useMapper.selectTypeRecall();
        if (list == null) {
            return null;
        }
        List<ComboxRep> repList = new ArrayList<>();
        for (int i = 0; i < list.size(); i++) {
            ComboxRep repObj = new ComboxRep(list.get(i));
            repObj.setId((i + 1) + "");
            repList.add(repObj);
        }
        return new ComboxReps((long) repList.size(), repList);
    }
}

